# hipRAND

hipRAND is a RAND marshalling library with multiple supported backends. It sits between your
application and the backend RAND library, where it marshals inputs to the backend and results to the
application. hipRAND exports an interface that doesn't require the client to change, regardless of the
chosen backend.

hipRAND supports [rocRAND](https://github.com/ROCm/rocRAND) and
[cuRAND](https://developer.nvidia.com/curand).

You can find our documentation at
[hipRAND User Guide/](https://rocm.docs.amd.com/projects/hipRAND/en/latest/).

## Documentation

To build our documentation, use the following commands:

```bash
# Go to hipRAND docs directory
cd hipRAND; cd docs

# Install Python dependencies
python3 -m pip install -r sphinx/requirements.txt

# Build the documentation
python3 -m sphinx -T -E -b html -d _build/doctrees -D language=en . _build/html

# E.g. serve the HTML docs locally
cd _build/html
python3 -m http.server
```

## Requirements

You must have the following installed to use hipRAND:

* CMake (3.16 or later)
* For AMD GPUs:
  * AMD ROCm Software (5.0.0 or later)
  * rocRAND library
* For NVIDIA GPUs:
  * CUDA Toolkit 11.5.1 or newer
  * cuRAND library

## Build and install

You can download pre-built packages by following the [ROCm Install Guide](https://rocm.docs.amd.com/projects/install-on-linux/en/latest/how-to/native-install/index.html),
or by clicking the github releases tab (this option could have a newer version).

Once downloaded, use the following command to install hipRAND:

`sudo apt update && sudo apt install hiprand`

To build hipRAND, you can use the bash helper script (Ubuntu only) or build manually (for all
supported platforms):

* Bash helper build script:

  The helper script `install` is located in the root repository. Note that this method doesn't take many
  options and hard-codes a configuration that you can specify by invoking CMake directly.

  A few commands in the script need sudo access, so it may prompt you for a password.

  * `./install -h`: Shows help
  * `./install -id`: Builds library, dependencies, and installs (the `-d` flag only needs to be passed once on
    a system)

* Manual build:

  If you use a distribution other than Ubuntu, or want more control over the build process, the
  [hipRAND build wiki](https://github.com/ROCm/hipRAND/wiki/Build) has helpful
  information on how to configure CMake and build manually.

### Supported functions

You can find a list of
[exported functions](https://github.com/ROCm/hipRAND/wiki/Exported-functions) on
the wiki.

## Interface examples

The hipRAND interface is compatible with rocRAND and cuRAND-v2 APIs. Porting a CUDA application
that calls the cuRAND API to an application that calls the hipRAND API is relatively straightforward. For
example, to create a generator:

### Host API

```c
hiprandStatus_t
hiprandCreateGenerator(
  hiprandGenerator_t* generator,
  hiprandRngType_t rng_type
)
```

### Device API

Here is an example that generates a log-normally distributed float from a generator (these functions
are templated for all generators).

```c
__device__ double
hiprand_log_normal_double(
  hiprandStateSobol64_t* state,
  double mean,
  double stddev
)
```

# hipRAND Python Wrapper

## Requirements

* rocRAND
* Python 3.5
* pip (only for installing)
* NumPy (will be installed automatically as a dependency if necessary)

If rocRAND is built from sources but not installed or installed in non-standard
directory set `ROCRAND_PATH` environment variable, for example:

```
export ROCRAND_PATH=~/rocRAND/build/library/
```

## Installing

```
cd python/hiprand
pip install .
```

Run tests:

```
python tests/hiprand_test.py
```

It is also possible to test the wrapper without installing:

```
python setup.py test
```

Run examples:

```
python examples/pi.py
```

## Creating a source distribution

```
cd python/hiprand
python setup.py sdist
```

The package `hiprand-<version>.tar.gz` will be placed into `dist/`.
It can be installed later using this command:

```
pip install hiprand-<version>.tar.gz
```

## Building documentation

Install Sphinx (http://www.sphinx-doc.org/en/stable/index.html):

```
pip install Sphinx
```

Run:

```
cd python/hiprand
python setup.py build_sphinx
```

The documentation will be placed into `docs/build/html`.

Note: Sphinx requires that the module is properly loaded to generate
documentation from sources. Consider to install rocRAND first
or set `ROCRAND_PATH` if you see error messages like
"ImportError: libhiprand.so cannot be loaded..."

# Examples

## Estimating Pi using Monte Carlo method

`pi.py` estimates the value of Pi using NumPy's and both hipRAND's pseudo-random
(Monte Carlo method) and quasi-random (Quasi-Monte Carlo method) number
generators.

The example requires [Matplotlib](http://matplotlib.org/users/installing.html#linux-using-your-package-manager).

References:
* https://en.wikipedia.org/wiki/Monte_Carlo_method
* https://en.wikipedia.org/wiki/Quasi-Monte_Carlo_method

!! Copyright (c) 2017-2023 Advanced Micro Devices, Inc. All rights reserved.
!!
!! Permission is hereby granted, free of charge, to any person obtaining a copy
!! of this software and associated documentation files (the "Software"), to deal
!! in the Software without restriction, including without limitation the rights
!! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
!! copies of the Software, and to permit persons to whom the Software is
!! furnished to do so, subject to the following conditions:
!!
!! The above copyright notice and this permission notice shall be included in
!! all copies or substantial portions of the Software.
!!
!! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
!! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
!! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
!! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
!! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
!! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
!! THE SOFTWARE.

module hipfor
    use iso_c_binding
    implicit none

    integer, public :: hipSuccess = 0

    integer, public :: hipMemcpyHostToHost = 0
    integer, public :: hipMemcpyHostToDevice = 1
    integer, public :: hipMemcpyDeviceToHost = 2
    integer, public :: hipMemcpyDeviceToDevice = 3
    integer, public :: hipMemcpyDefault = 4

    type, bind(C) :: dim3
        integer(c_int) :: x, y, z
    end type dim3

    interface
        function hipMalloc(ptr, length) bind(C, name = "hipMalloc")
            use iso_c_binding
            implicit none
            type(c_ptr) :: ptr
            integer(c_size_t), value :: length
            integer(c_int) :: hipMalloc
        end function

        function hipMemcpy(dst, src, length, dir) bind(C, name = "hipMemcpy")
            use iso_c_binding
            implicit none
            type(c_ptr), value :: dst, src
            integer(c_size_t), value :: length
            integer(c_int), value :: dir
            integer(c_int) :: hipMemcpy
            end function

        function hipFree(ptr) bind(C, name = "hipFree")
            use iso_c_binding
            implicit none
            type(c_ptr), value :: ptr
            integer(c_int) :: hipFree
        end function

        function hipDeviceSynchronize() bind(C, name = "hipDeviceSynchronize")
            use iso_c_binding
            implicit none
            integer(c_int) :: hipDeviceSynchronize
        end function
    end interface

end module

! Copyright (c) 2005-2010, 2012-2013, Andrew Hang Chen and contributors,
! All rights reserved.
! Licensed under the 3-clause BSD license.

module fruit_util
  private
  
  public :: equals, to_s, strip
  
  interface equals
     module procedure equalEpsilon
     module procedure floatEqual
     module procedure integerEqual
     module procedure doublePrecisionEqual
     module procedure stringEqual
     module procedure logicalEqual
  end interface

  interface to_s
     module procedure to_s_int_
     module procedure to_s_real_
     module procedure to_s_logical_
     module procedure to_s_double_
     module procedure to_s_complex_
     module procedure to_s_double_complex_
     module procedure to_s_string_
  end interface

  interface strip
    module procedure strip_
    module procedure strip_length_
  end interface
contains

  function to_s_int_ (value)
    implicit none
    character(len=500):: to_s_int_
    integer, intent(in) :: value
    character(len=500) :: result
    write (result, *) value
    to_s_int_ = adjustl(trim(result))
  end function to_s_int_

  function to_s_real_ (value)
    implicit none
    character(len=500):: to_s_real_
    real, intent(in) :: value
    character(len=500) :: result
    write (result, *) value
    to_s_real_ = adjustl(trim(result))
  end function to_s_real_

  function to_s_double_ (value)
    implicit none
    character(len=500):: to_s_double_
    double precision, intent(in) :: value
    character(len=500) :: result
    write (result, *) value
    to_s_double_ = adjustl(trim(result))
  end function to_s_double_

  function to_s_complex_ (value)
    implicit none
    character(len=500):: to_s_complex_
    complex, intent(in) :: value
    character(len=500) :: result
    write (result, *) value
    to_s_complex_ = adjustl(trim(result))
  end function to_s_complex_

  function to_s_double_complex_ (value)
    implicit none
    character(len=500):: to_s_double_complex_
    complex(kind=kind(1.0D0)), intent(in) :: value
    character(len=500) :: result
    write (result, *) value
    to_s_double_complex_ = adjustl(trim(result))
  end function to_s_double_complex_

  function to_s_logical_ (value)
    implicit none
    character(len=500):: to_s_logical_
    logical, intent(in) :: value
    character(len=500) :: result
    write (result, *) value
    to_s_logical_ = adjustl(trim(result))
  end function to_s_logical_

  function to_s_string_ (value)
    implicit none
    character(len=500):: to_s_string_
    character(len=*), intent(in) :: value
    to_s_string_ = value
  end function to_s_string_

  function strip_(value)
    implicit none
    character(len=500):: strip_
    character(len=*), intent(in) :: value
    strip_ = trim(adjustl(value))
  end function strip_

  function strip_length_(value, length)
    implicit none
    character(len=*), intent(in) :: value
    integer, intent(in) :: length
    character(len= length):: strip_length_
    strip_length_ = trim(adjustl(value))
  end function strip_length_

  !------------------------
  ! test if 2 values are close
  !------------------------
  !logical function equals (number1, number2) 
  !  real,  intent (in) :: number1, number2
  !  
  !  return equalEpsilon (number1, number2, epsilon(number1))
  !
  !end function equals


  function equalEpsilon (number1, number2, epsilon ) result (resultValue)
    real , intent (in) :: number1, number2, epsilon 
    logical :: resultValue 

    resultValue = .false.

    ! test very small number1
    if ( abs(number1) < epsilon .and.  abs(number1 - number2) < epsilon ) then
       resultValue = .true.
    else 
       if ((abs(( number1 - number2)) / number1) < epsilon ) then
          resultValue = .true.
       else
          resultValue = .false.
       end if
    end if

  end function equalEpsilon

  function floatEqual (number1, number2 ) result (resultValue)
    real , intent (in) :: number1, number2
    real :: epsilon 
    logical :: resultValue 

    resultValue = .false.
    epsilon = 1E-6

    ! test very small number1
    if ( abs(number1) < epsilon .and.  abs(number1 - number2) < epsilon ) then
       resultValue = .true.
    else 
       if ((abs(( number1 - number2)) / number1) < epsilon ) then
          resultValue = .true.
       else
          resultValue = .false.
       end if
    end if
  end function floatEqual

  function doublePrecisionEqual (number1, number2 ) result (resultValue)
    double precision , intent (in) :: number1, number2
    real :: epsilon 
    logical :: resultValue 

    resultValue = .false.
    epsilon = 1E-6
    !epsilon = epsilon (number1)

    ! test very small number1
    if ( abs(number1) < epsilon .and.  abs(number1 - number2) < epsilon ) then
       resultValue = .true.
    else 
       if ((abs(( number1 - number2)) / number1) < epsilon ) then
          resultValue = .true.
       else
          resultValue = .false.
       end if
    end if
  end function doublePrecisionEqual

  function integerEqual (number1, number2 ) result (resultValue)
    integer , intent (in) :: number1, number2
    logical :: resultValue 

    resultValue = .false.

    if ( number1 .eq. number2 ) then
       resultValue = .true.
    else 
       resultValue = .false.
    end if
  end function integerEqual

  function stringEqual (str1, str2 ) result (resultValue)
    character(*) , intent (in) :: str1, str2
    logical :: resultValue 

    resultValue = .false.

    if ( str1 .eq. str2 ) then
       resultValue = .true.
    end if
  end function stringEqual

  function logicalEqual (l1, l2 ) result (resultValue)
    logical, intent (in) :: l1, l2
    logical              :: resultValue 

    resultValue = .false.

    if ( l1 .eqv. l2 ) then
       resultValue = .true.
    end if
  end function logicalEqual

end module fruit_util

!! Copyright (c) 2017-2023 Advanced Micro Devices, Inc. All rights reserved.
!!
!! Permission is hereby granted, free of charge, to any person obtaining a copy
!! of this software and associated documentation files (the "Software"), to deal
!! in the Software without restriction, including without limitation the rights
!! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
!! copies of the Software, and to permit persons to whom the Software is
!! furnished to do so, subject to the following conditions:
!!
!! The above copyright notice and this permission notice shall be included in
!! all copies or substantial portions of the Software.
!!
!! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
!! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
!! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
!! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
!! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
!! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
!! THE SOFTWARE.

module test_hiprand
    use fruit
    use fruit_helpers
    use hipfor
    use hiprand_m

    implicit none

contains

    !> Initialise test suite - no-op.
    subroutine setup
    end subroutine setup

    !> Clean up test suite - no-op.
    subroutine teardown
    end subroutine teardown

    !> Test generator functions
    subroutine test_init()
        integer(kind =8) :: gen
        integer(kind =8), parameter :: seed = 5, offset = 10
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandCreateGenerator(gen, &
        HIPRAND_RNG_PSEUDO_DEFAULT))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandGenerateSeeds(gen))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandSetPseudoRandomGeneratorSeed(gen, seed))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandSetGeneratorOffset(gen, offset))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandDestroyGenerator(gen))
    end subroutine test_init

    !> Test hiprandGenerate.
    subroutine test_hiprandGenerate()
        integer(kind =8) :: gen
        integer(kind =4), target, dimension(128) :: h_x
        type(c_ptr) :: d_x
        integer(c_size_t), parameter :: output_size = 128
        call assert_equals(hipSuccess, hipMalloc(d_x, output_size * sizeof(h_x(1))))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandCreateGenerator(gen, &
        HIPRAND_RNG_PSEUDO_DEFAULT))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandGenerate(gen, d_x, output_size))
        call assert_equals(hipSuccess, hipMemcpy(c_loc(h_x), d_x, output_size * sizeof(h_x(1)), &
        hipMemcpyDeviceToHost))
        call assert_equals(hipSuccess, hipFree(d_x))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandDestroyGenerator(gen))
    end subroutine test_hiprandGenerate

    !> Test hiprandGenerate with host generator.
    subroutine test_hiprandGenerate_host()
        integer(kind =8) :: gen
        integer(kind =4), target, dimension(128) :: h_x
        integer(c_size_t), parameter :: output_size = 128
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandCreateGeneratorHost(gen, &
        HIPRAND_RNG_PSEUDO_PHILOX4_32_10))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandGenerate(gen, c_loc(h_x), output_size))
        call assert_equals(hipSuccess, hipDeviceSynchronize())
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandDestroyGenerator(gen))
    end subroutine test_hiprandGenerate_host

    !> Test hiprandGenerateLongLong.
    subroutine test_hiprandGenerateLongLong()
        integer(kind =8) :: gen
        integer(kind =8), target, dimension(128) :: h_x
        type(c_ptr) :: d_x
        integer(c_size_t), parameter :: output_size = 128
        call assert_equals(hipSuccess, hipMalloc(d_x, output_size * sizeof(h_x(1))))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandCreateGenerator(gen, &
        HIPRAND_RNG_QUASI_SOBOL64))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandGenerateLongLong(gen, d_x, output_size))
        call assert_equals(hipSuccess, hipMemcpy(c_loc(h_x), d_x, output_size * sizeof(h_x(1)), &
        hipMemcpyDeviceToHost))
        call assert_equals(hipSuccess, hipFree(d_x))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandDestroyGenerator(gen))
    end subroutine test_hiprandGenerateLongLong

    !> Test hiprandGenerateUniform.
    subroutine test_hiprandGenerateUniform()
        integer(kind =8) :: gen
        real, target, dimension(128) :: h_x
        type(c_ptr) :: d_x
        integer(c_size_t), parameter :: output_size = 128
        real, parameter :: mean = 0.5, delta = 0.1
        call assert_equals(hipSuccess, hipMalloc(d_x, output_size * sizeof(h_x(1))))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandCreateGenerator(gen, &
        HIPRAND_RNG_PSEUDO_DEFAULT))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandGenerateUniform(gen, d_x, output_size))
        call assert_equals(hipSuccess, hipMemcpy(c_loc(h_x), d_x, output_size * sizeof(h_x(1)), &
        hipMemcpyDeviceToHost))
        call assert_equals((sum(h_x) / output_size), mean, delta)
        call assert_equals(hipSuccess, hipFree(d_x))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandDestroyGenerator(gen))
    end subroutine test_hiprandGenerateUniform

    !> Test hiprandGenerateUniformDouble.
    subroutine test_hiprandGenerateUniformDouble()
        integer(kind =8) :: gen
        double precision, target, dimension(128) :: h_x
        type(c_ptr) :: d_x
        integer(c_size_t), parameter :: output_size = 128
        double precision, parameter :: mean = 0.5, delta = 0.1
        call assert_equals(hipSuccess, hipMalloc(d_x, output_size * sizeof(h_x(1))))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandCreateGenerator(gen, &
        HIPRAND_RNG_PSEUDO_DEFAULT))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandGenerateUniformDouble(gen, d_x, &
        output_size))
        call assert_equals(hipSuccess, hipMemcpy(c_loc(h_x), d_x, output_size * sizeof(h_x(1)), &
        hipMemcpyDeviceToHost))
        call assert_equals((sum(h_x) / output_size), mean, delta)
        call assert_equals(hipSuccess, hipFree(d_x))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandDestroyGenerator(gen))
    end subroutine test_hiprandGenerateUniformDouble

    !> Test hiprandGenerateNormal.
    subroutine test_hiprandGenerateNormal()
        integer(kind =8) :: gen
        real, target, dimension(128) :: h_x
        type(c_ptr) :: d_x
        integer(c_size_t), parameter :: output_size = 128
        real, parameter :: mean = 0.0, stddev = 1.0, delta = 0.2
        call assert_equals(hipSuccess, hipMalloc(d_x, output_size * sizeof(h_x(1))))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandCreateGenerator(gen, &
        HIPRAND_RNG_PSEUDO_DEFAULT))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandGenerateNormal(gen, d_x, &
        output_size, mean, stddev))
        call assert_equals(hipSuccess, hipMemcpy(c_loc(h_x), d_x, output_size * sizeof(h_x(1)), &
        hipMemcpyDeviceToHost))
        call assert_equals((sum(h_x) / output_size), mean, delta)
        call assert_equals(sqrt(sum((h_x - mean) ** 2) / output_size), stddev, delta)
        call assert_equals(hipSuccess, hipFree(d_x))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandDestroyGenerator(gen))
    end subroutine test_hiprandGenerateNormal

    !> Test hiprandGenerateNormalDouble.
    subroutine test_hiprandGenerateNormalDouble()
        integer(kind =8) :: gen
        double precision, target, dimension(128) :: h_x
        type(c_ptr) :: d_x
        integer(c_size_t), parameter :: output_size = 128
        double precision, parameter :: mean = 0.0, stddev = 1.0, delta = 0.2
        call assert_equals(hipSuccess, hipMalloc(d_x, output_size * sizeof(h_x(1))))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandCreateGenerator(gen, &
        HIPRAND_RNG_PSEUDO_DEFAULT))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandGenerateNormalDouble(gen, d_x, &
        output_size, mean, stddev))
        call assert_equals(hipSuccess, hipMemcpy(c_loc(h_x), d_x, output_size * sizeof(h_x(1)), &
        hipMemcpyDeviceToHost))
        call assert_equals((sum(h_x) / output_size), mean, delta)
        call assert_equals(sqrt(sum((h_x - mean) ** 2) / output_size), stddev, delta)
        call assert_equals(hipSuccess, hipFree(d_x))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandDestroyGenerator(gen))
    end subroutine test_hiprandGenerateNormalDouble

    !> Test hiprandGenerateLogNormal.
    subroutine test_hiprandGenerateLogNormal()
        integer(kind =8) :: gen
        real, target, dimension(128) :: h_x
        type(c_ptr) :: d_x
        integer(c_size_t), parameter :: output_size = 128
        real, parameter :: mean = 1.6, stddev = 0.25, delta = 0.2
        real :: m, s
        call assert_equals(hipSuccess, hipMalloc(d_x, output_size * sizeof(h_x(1))))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandCreateGenerator(gen, &
        HIPRAND_RNG_PSEUDO_DEFAULT))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandGenerateLogNormal(gen, d_x, &
        output_size, mean, stddev))
        call assert_equals(hipSuccess, hipMemcpy(c_loc(h_x), d_x, output_size * sizeof(h_x(1)), &
        hipMemcpyDeviceToHost))
        m = sum(h_x) / output_size
        s = sqrt(sum((h_x - mean) ** 2) / output_size)
        call assert_equals(log(m * m / sqrt(s + m * m)), mean, delta)
        call assert_equals(sqrt(log(1.0 + s / (m * m))), stddev, delta)
        call assert_equals(hipSuccess, hipFree(d_x))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandDestroyGenerator(gen))
    end subroutine test_hiprandGenerateLogNormal

    !> Test hiprandGenerateLogNormalDouble.
    subroutine test_hiprandGenerateLogNormalDouble()
        integer(kind =8) :: gen
        double precision, target, dimension(128) :: h_x
        type(c_ptr) :: d_x
        integer(c_size_t), parameter :: output_size = 128
        double precision, parameter :: mean = 1.6, stddev = 0.25, delta = 0.2
        double precision :: m, s
        call assert_equals(hipSuccess, hipMalloc(d_x, output_size * sizeof(h_x(1))))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandCreateGenerator(gen, &
        HIPRAND_RNG_PSEUDO_DEFAULT))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandGenerateLogNormalDouble(gen, d_x, &
        output_size, mean, stddev))
        call assert_equals(hipSuccess, hipMemcpy(c_loc(h_x), d_x, output_size * sizeof(h_x(1)), &
        hipMemcpyDeviceToHost))
        m = sum(h_x) / output_size
        s = sqrt(sum((h_x - mean) ** 2) / output_size)
        call assert_equals(log(m * m / sqrt(s + m * m)), mean, delta)
        call assert_equals(sqrt(log(1.0 + s / (m * m))), stddev, delta)
        call assert_equals(hipSuccess, hipFree(d_x))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandDestroyGenerator(gen))
    end subroutine test_hiprandGenerateLogNormalDouble

    !> Test hiprandGeneratePoisson.
    subroutine test_hiprandGeneratePoisson()
        integer(kind =8) :: gen, distribution
        integer(kind =4), target, dimension(128) :: h_x
        type(c_ptr) :: d_x
        integer(c_size_t), parameter :: output_size = 128
        double precision, parameter :: lambda = 20.0
        call assert_equals(hipSuccess, hipMalloc(d_x, output_size * sizeof(h_x(1))))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandCreateGenerator(gen, &
        HIPRAND_RNG_PSEUDO_DEFAULT))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandCreatePoissonDistribution(lambda, &
        distribution))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandGeneratePoisson(gen, d_x, &
        output_size, lambda))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandDestroyDistribution( &
        distribution))
        call assert_equals(hipSuccess, hipMemcpy(c_loc(h_x), d_x, output_size * sizeof(h_x(1)), &
        hipMemcpyDeviceToHost))
        call assert_equals(hipSuccess, hipFree(d_x))
        call assert_equals(HIPRAND_STATUS_SUCCESS, hiprandDestroyGenerator(gen))
    end subroutine test_hiprandGeneratePoisson

    !> Call each test.
    subroutine hiprand_basket()
    character(len=*) :: suite_name
    parameter(suite_name='test_hiprand')

    call run_fruit_test_case(test_init,'test_init',&
        setup,teardown,suite_name)

    call run_fruit_test_case(test_hiprandGenerate,'test_hiprandGenerate',&
        setup,teardown,suite_name)

    call run_fruit_test_case(test_hiprandGenerate_host,'test_hiprandGenerate_host',&
        setup,teardown,suite_name)

    call run_fruit_test_case(test_hiprandGenerateLongLong,'test_hiprandGenerateLongLong',&
        setup,teardown,suite_name)

    call run_fruit_test_case(test_hiprandGenerateUniform,'test_hiprandGenerateUniform',&
        setup,teardown,suite_name)

    call run_fruit_test_case(test_hiprandGenerateUniformDouble, &
        'test_hiprandGenerateUniformDouble',setup,teardown,suite_name)

    call run_fruit_test_case(test_hiprandGenerateNormal,'test_hiprandGenerateNormal',&
        setup,teardown,suite_name)

    call run_fruit_test_case(test_hiprandGenerateNormalDouble, &
        'test_hiprandGenerateNormalDouble',setup,teardown,suite_name)

    call run_fruit_test_case(test_hiprandGenerateLogNormal,'test_hiprandGenerateLogNormal',&
        setup,teardown,suite_name)

    call run_fruit_test_case(test_hiprandGenerateLogNormalDouble, &
        'test_hiprandGenerateLogNormalDouble',setup,teardown,suite_name)

    call run_fruit_test_case(test_hiprandGeneratePoisson,'test_hiprandGeneratePoisson',&
        setup,teardown,suite_name)

    end subroutine hiprand_basket

end module test_hiprand

!! Copyright (c) 2017-2023 Advanced Micro Devices, Inc. All rights reserved.
!!
!! Permission is hereby granted, free of charge, to any person obtaining a copy
!! of this software and associated documentation files (the "Software"), to deal
!! in the Software without restriction, including without limitation the rights
!! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
!! copies of the Software, and to permit persons to whom the Software is
!! furnished to do so, subject to the following conditions:
!!
!! The above copyright notice and this permission notice shall be included in
!! all copies or substantial portions of the Software.
!!
!! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
!! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
!! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
!! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
!! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
!! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
!! THE SOFTWARE.

module hiprand_m
    use hipfor

    integer, public :: HIPRAND_RNG_PSEUDO_DEFAULT = 400
    integer, public :: HIPRAND_RNG_PSEUDO_XORWOW = 401
    integer, public :: HIPRAND_RNG_PSEUDO_MRG32K3A = 402
    integer, public :: HIPRAND_RNG_PSEUDO_MTGP32 = 403
    integer, public :: HIPRAND_RNG_PSEUDO_MT19937 = 404
    integer, public :: HIPRAND_RNG_PSEUDO_PHILOX4_32_10 = 405
    integer, public :: HIPRAND_RNG_QUASI_DEFAULT = 500
    integer, public :: HIPRAND_RNG_QUASI_SOBOL32 = 501
    integer, public :: HIPRAND_RNG_QUASI_SCRAMBLED_SOBOL32 = 502
    integer, public :: HIPRAND_RNG_QUASI_SOBOL64 = 503
    integer, public :: HIPRAND_RNG_QUASI_SCRAMBLED_SOBOL64 = 504

    integer, public :: HIPRAND_STATUS_SUCCESS = 0
    integer, public :: HIPRAND_STATUS_VERSION_MISMATCH  = 100
    integer, public :: HIPRAND_STATUS_NOT_INITIALIZED  = 101
    integer, public :: HIPRAND_STATUS_ALLOCATION_FAILED  = 102
    integer, public :: HIPRAND_STATUS_TYPE_ERROR = 103
    integer, public :: HIPRAND_STATUS_OUT_OF_RANGE  = 104
    integer, public :: HIPRAND_STATUS_LENGTH_NOT_MULTIPLE  = 105
    integer, public :: HIPRAND_STATUS_DOUBLE_PRECISION_REQUIRED  = 106
    integer, public :: HIPRAND_STATUS_LAUNCH_FAILURE  = 201
    integer, public :: HIPRAND_STATUS_PREEXISTING_FAILURE  = 202
    integer, public :: HIPRAND_STATUS_INITIALIZATION_FAILED  = 203
    integer, public :: HIPRAND_STATUS_ARCH_MISMATCH  = 204
    integer, public :: HIPRAND_STATUS_INTERNAL_ERROR  = 999
    integer, public :: HIPRAND_STATUS_NOT_IMPLEMENTED  = 1000

    interface
        function hiprandCreateGenerator(generator, rng_type) &
        bind(C, name="hiprandCreateGenerator")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandCreateGenerator
            integer(c_size_t) :: generator
            integer(c_int), value :: rng_type
        end function

        function hiprandCreateGeneratorHost(generator, rng_type) &
        bind(C, name="hiprandCreateGeneratorHost")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandCreateGeneratorHost
            integer(c_size_t) :: generator
            integer(c_int), value :: rng_type
        end function

        function hiprandDestroyGenerator(generator) &
        bind(C, name="hiprandDestroyGenerator")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandDestroyGenerator
            integer(c_size_t), value :: generator
        end function

        function hiprandGenerate(generator, output_data, n) &
        bind(C, name="hiprandGenerate")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandGenerate
            integer(c_size_t), value :: generator
            type(c_ptr), value :: output_data
            integer(c_size_t), value :: n
        end function

        function hiprandGenerateLongLong(generator, output_data, n) &
        bind(C, name="hiprandGenerateLongLong")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandGenerateLongLong
            integer(c_size_t), value :: generator
            type(c_ptr), value :: output_data
            integer(c_size_t), value :: n
        end function

        function hiprandGenerateUniform(generator, output_data, n) &
        bind(C, name="hiprandGenerateUniform")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandGenerateUniform
            integer(c_size_t), value :: generator
            type(c_ptr), value :: output_data
            integer(c_size_t), value :: n
        end function

        function hiprandGenerateUniformDouble(generator, output_data, n) &
        bind(C, name="hiprandGenerateUniformDouble")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandGenerateUniformDouble
            integer(c_size_t), value :: generator
            type(c_ptr), value :: output_data
            integer(c_size_t), value :: n
        end function

        function hiprandGenerateNormal(generator, output_data, n, mean, &
        stddev) bind(C, name="hiprandGenerateNormal")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandGenerateNormal
            integer(c_size_t), value :: generator
            type(c_ptr), value :: output_data
            integer(c_size_t), value :: n
            real(c_float), value :: mean
            real(c_float), value :: stddev
        end function

        function hiprandGenerateNormalDouble(generator, output_data, n, &
        mean, stddev) bind(C, name="hiprandGenerateNormalDouble")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandGenerateNormalDouble
            integer(c_size_t), value :: generator
            type(c_ptr), value :: output_data
            integer(c_size_t), value :: n
            real(c_double), value :: mean
            real(c_double), value :: stddev
        end function

        function hiprandGenerateLogNormal(generator, output_data, n, mean, &
        stddev) bind(C, name="hiprandGenerateLogNormal")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandGenerateLogNormal
            integer(c_size_t), value :: generator
            type(c_ptr), value :: output_data
            integer(c_size_t), value :: n
            real(c_float), value :: mean
            real(c_float), value :: stddev
        end function

        function hiprandGenerateLogNormalDouble(generator, output_data, n, &
        mean, stddev) bind(C, name="hiprandGenerateLogNormalDouble")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandGenerateLogNormalDouble
            integer(c_size_t), value :: generator
            type(c_ptr), value :: output_data
            integer(c_size_t), value :: n
            real(c_double), value :: mean
            real(c_double), value :: stddev
        end function

        function hiprandGeneratePoisson(generator, output_data, n, lambda) &
        bind(C, name="hiprandGeneratePoisson")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandGeneratePoisson
            integer(c_size_t), value :: generator
            type(c_ptr), value :: output_data
            integer(c_size_t), value :: n
            real(c_double), value :: lambda
        end function

        function hiprandGenerateSeeds(generator) &
        bind(C, name="hiprandGenerateSeeds")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandGenerateSeeds
            integer(c_size_t), value :: generator
        end function

        function hiprandSetStream(generator, stream) &
        bind(C, name="hiprandSetStream")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandSetStream
            integer(c_size_t), value :: generator
            integer(c_size_t), value :: stream
        end function

        function hiprandSetPseudoRandomGeneratorSeed(generator, seed) &
        bind(C, name="hiprandSetPseudoRandomGeneratorSeed")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandSetPseudoRandomGeneratorSeed
            integer(c_size_t), value :: generator
            integer(kind =8), value :: seed
        end function

        function hiprandSetGeneratorOffset(generator, offset) &
        bind(C, name="hiprandSetGeneratorOffset")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandSetGeneratorOffset
            integer(c_size_t), value :: generator
            integer(kind =8), value :: offset
        end function

        function hiprandSetQuasiRandomGeneratorDimensions(generator, &
        dimensions) bind(C, name="hiprandSetQuasiRandomGeneratorDimensions")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandSetQuasiRandomGeneratorDimensions
            integer(c_size_t), value :: generator
            integer(c_int), value :: dimensions
        end function

        function hiprandGetVersion(version) &
        bind(C, name="hiprandGetVersion")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandGetVersion
            integer(c_int) :: version
        end function

        function hiprandCreatePoissonDistribution(lambda, &
        discrete_distribution) bind(C, name="hiprandCreatePoissonDistribution")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandCreatePoissonDistribution
            real(c_double), value :: lambda
            integer(c_size_t) :: discrete_distribution
        end function

        function hiprandDestroyDistribution(discrete_distribution) &
        bind(C, name="hiprandDestroyDistribution")
            use iso_c_binding
            implicit none
            integer(c_int) :: hiprandDestroyDistribution
            integer(c_size_t), value :: discrete_distribution
        end function
    end interface
end module hiprand_m

!> FRUIT unit test framework helper subroutines.
!! Based on driver code auto-generated by FRUIT's Ruby pre-processor.

!! Copyright (c) 2017 Advanced Micro Devices, Inc. All rights reserved.
!!
!! Permission is hereby granted, free of charge, to any person obtaining a copy
!! of this software and associated documentation files (the "Software"), to deal
!! in the Software without restriction, including without limitation the rights
!! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
!! copies of the Software, and to permit persons to whom the Software is
!! furnished to do so, subject to the following conditions:
!!
!! The above copyright notice and this permission notice shall be included in
!! all copies or substantial portions of the Software.
!!
!! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
!! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
!! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
!! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
!! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
!! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
!! THE SOFTWARE.

module fruit_helpers

  use fruit
  implicit none

contains

  !> Invoke a test case sub-routine of a test suite, invoking the
  !! suite's setup sub-routine first, and its teardown sub-routine
  !! after. This sub-routine was abstracted out from "basket" code
  !! auto-generated by FRUIT's Ruby pre-processor.
  subroutine run_fruit_test_case(test_case,test_case_name, &
    setup,teardown,test_suite_name)
    interface
      subroutine test_case()
      end subroutine
    end interface
    character(*),intent(in) :: test_case_name
    interface
      subroutine setup()
      end subroutine
    end interface
    interface
      subroutine teardown()
      end subroutine
    end interface
    character(*),intent(in) :: test_suite_name

    call setup()
    write(*,'(/A,A,A,A)') 'Running: ',test_suite_name,':',test_case_name
    call set_unit_name(test_case_name)
    call run_test_case(test_case,test_case_name)
    if (.not. is_case_passed()) then
      call case_failed_xml(test_case_name,test_suite_name)
    else
      call case_passed_xml(test_case_name,test_suite_name)
    end if
    call teardown()
  end subroutine run_fruit_test_case

end module fruit_helpers

!> FRUIT unit test framework helper subroutines.
!! Based on driver code auto-generated by FRUIT's Ruby pre-processor.

!! Copyright (c) 2017 Advanced Micro Devices, Inc. All rights reserved.
!!
!! Permission is hereby granted, free of charge, to any person obtaining a copy
!! of this software and associated documentation files (the "Software"), to deal
!! in the Software without restriction, including without limitation the rights
!! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
!! copies of the Software, and to permit persons to whom the Software is
!! furnished to do so, subject to the following conditions:
!!
!! The above copyright notice and this permission notice shall be included in
!! all copies or substantial portions of the Software.
!!
!! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
!! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
!! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
!! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
!! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
!! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
!! THE SOFTWARE.

program fruit_test_driver_hiprand

    use fruit

    ! Add modules here...
    use test_hiprand

    call init_fruit()
    call init_fruit_xml()

    ! Add module basket calls here..
    call hiprand_basket()

    call fruit_summary()
    call fruit_summary_xml()
    call fruit_finalize()

end program fruit_test_driver_hiprand

! Copyright (c) 2005-2010, 2012-2013, Andrew Hang Chen and contributors,
! All rights reserved.
! Licensed under the 3-clause BSD license.

!------------------------
! FORTRAN unit test utility
!
! Author: Andrew H. Chen meihome @at@ gmail.com
!------------------------
!
! Unit test framework for FORTRAN.  (FoRtran UnIT)
!
! This package is to perform unit test for FORTRAN subroutines
!
! The method used most are: assert_true, assert_equals
!
! Coding convention:
!   1) All methods must be exposed by interface.  i.e. interface init_fruit
!   2) Variable and methods are lower case connected with underscores.  i.e. init_fruit, and
!      failed_assert_count
!
module fruit
  use fruit_util
  implicit none
  private

  integer, parameter :: STDOUT_DEFAULT = 6
  integer :: stdout   = STDOUT_DEFAULT

  integer, parameter :: XML_OPEN = 20
  integer, parameter :: XML_WORK_DEFAULT = 21
  integer :: xml_work = XML_WORK_DEFAULT
  character (len = *), parameter :: xml_filename     = "result.xml"
  character (len = *), parameter :: XML_FN_WORK_DEF = "result_tmp.xml"
  character (len = 50) :: xml_filename_work = XML_FN_WORK_DEF

  integer, parameter :: STRLEN_T = 12

  integer, parameter :: NUMBER_LENGTH = 10

  integer, parameter :: MSG_LENGTH = 256
  integer, parameter :: MAX_MSG_STACK_SIZE = 2000
  integer, parameter :: MSG_ARRAY_INCREMENT = 50
  integer, parameter :: MAX_MARKS_PER_LINE = 78

  character(*), parameter :: DEFAULT_CASE_NAME = '_not_set_'

  !---------- save ----------
  integer, private, save :: successful_assert_count = 0
  integer, private, save :: failed_assert_count = 0

  integer, private, save :: message_index = 1
  integer, private, save :: message_index_from = 1
  integer, private, save :: current_max = 50

  character (len = MSG_LENGTH), private, allocatable :: message_array(:)
  character (len = MSG_LENGTH), private, save :: msg = '[unit name not set from set_name]: '
  character (len = MSG_LENGTH), private, save :: case_name  = DEFAULT_CASE_NAME

  integer, private, save :: successful_case_count = 0
  integer, private, save :: failed_case_count = 0
  integer, private, save :: testCaseIndex = 1
  logical, private, save :: last_passed = .false.
  logical, private, save :: case_passed = .false.
  integer, private, save :: case_time_from = 0
  integer, private, save :: linechar_count = 0

  integer, parameter :: FRUIT_PREFIX_LEN_MAX = 50
  character(len = FRUIT_PREFIX_LEN_MAX) :: prefix = ""
  !---------- save ----------

  type ty_stack
    integer :: successful_assert_count
    integer :: failed_assert_count

    integer :: message_index
    integer :: message_index_from
    integer :: current_max

    character (len = MSG_LENGTH), pointer :: message_array(:)
    character (len = MSG_LENGTH) :: case_name !  = DEFAULT_CASE_NAME

    integer :: successful_case_count
    integer :: failed_case_count
    integer :: testCaseIndex
    logical :: last_passed
    logical :: case_passed
    integer :: case_time_from
    integer :: linechar_count
  end type ty_stack

  type(ty_stack), save :: stashed_suite

  public :: &
    init_fruit
  public :: &
    get_last_message, &
    is_last_passed, &
    is_case_passed, &
    add_success, addSuccess, &
    set_unit_name, get_unit_name, &
    set_case_name, get_case_name, &
    failed_assert_action, get_total_count, getTotalCount, &
    get_failed_count, getFailedCount, is_all_successful, isAllSuccessful, &
    run_test_case, runTestCase
  public :: assert_equals,     assertEquals
  public :: assert_not_equals, assertNotEquals
  public :: assert_true,       assertTrue
  public :: stash_test_suite, restore_test_suite
  public :: FRUIT_PREFIX_LEN_MAX
  public :: override_xml_work, end_override_xml_work
  public :: get_assert_and_case_count
  public :: fruit_summary_table

  public :: initializeFruit
  interface initializeFruit
     module procedure obsolete_initializeFruit_
  end interface

  public :: getTestSummary
  interface getTestSummary
     module procedure obsolete_getTestSummary_
  end interface

  interface assertTrue
     module procedure obsolete_assert_true_logical_
  end interface

  public ::          assert_false
  interface          assert_false
    module procedure assert_false_
  end interface

  interface assert_equals
  !====== begin of generated interface ======
    module procedure assert_eq_logical_
    module procedure assert_eq_1d_logical_
    module procedure assert_eq_2d_logical_
    module procedure assert_eq_string_
    module procedure assert_eq_1d_string_
    module procedure assert_eq_2d_string_
    module procedure assert_eq_int_
    module procedure assert_eq_1d_int_
    module procedure assert_eq_2d_int_
    module procedure assert_eq_real_
    module procedure assert_eq_real_in_range_
    module procedure assert_eq_1d_real_
    module procedure assert_eq_1d_real_in_range_
    module procedure assert_eq_2d_real_
    module procedure assert_eq_2d_real_in_range_
    module procedure assert_eq_double_
    module procedure assert_eq_double_in_range_
    module procedure assert_eq_1d_double_
    module procedure assert_eq_1d_double_in_range_
    module procedure assert_eq_2d_double_
    module procedure assert_eq_2d_double_in_range_
    module procedure assert_eq_complex_
    module procedure assert_eq_complex_in_range_
    module procedure assert_eq_1d_complex_
    module procedure assert_eq_1d_complex_in_range_
    module procedure assert_eq_2d_complex_
    module procedure assert_eq_2d_complex_in_range_
  !====== end of generated inteface ======
  end interface

  interface assertEquals
  !====== begin of generated interface ======
    module procedure assert_eq_logical_
    module procedure assert_eq_1d_logical_
    module procedure assert_eq_2d_logical_
    module procedure assert_eq_string_
    module procedure assert_eq_1d_string_
    module procedure assert_eq_2d_string_
    module procedure assert_eq_int_
    module procedure assert_eq_1d_int_
    module procedure assert_eq_2d_int_
    module procedure assert_eq_real_
    module procedure assert_eq_real_in_range_
    module procedure assert_eq_1d_real_
    module procedure assert_eq_1d_real_in_range_
    module procedure assert_eq_2d_real_
    module procedure assert_eq_2d_real_in_range_
    module procedure assert_eq_double_
    module procedure assert_eq_double_in_range_
    module procedure assert_eq_1d_double_
    module procedure assert_eq_1d_double_in_range_
    module procedure assert_eq_2d_double_
    module procedure assert_eq_2d_double_in_range_
    module procedure assert_eq_complex_
    module procedure assert_eq_complex_in_range_
    module procedure assert_eq_1d_complex_
    module procedure assert_eq_1d_complex_in_range_
    module procedure assert_eq_2d_complex_
    module procedure assert_eq_2d_complex_in_range_
  !====== end of generated inteface ======
  end interface

  interface assert_not_equals
  !====== begin of generated interface ======
    module procedure assert_not_equals_logical_
    module procedure assert_not_equals_1d_logical_
    module procedure assert_not_equals_2d_logical_
    module procedure assert_not_equals_string_
    module procedure assert_not_equals_1d_string_
    module procedure assert_not_equals_2d_string_
    module procedure assert_not_equals_int_
    module procedure assert_not_equals_1d_int_
    module procedure assert_not_equals_2d_int_
    module procedure assert_not_equals_real_
    module procedure assert_not_equals_real_in_range_
    module procedure assert_not_equals_1d_real_
    module procedure assert_not_equals_1d_real_in_range_
    module procedure assert_not_equals_2d_real_
    module procedure assert_not_equals_2d_real_in_range_
    module procedure assert_not_equals_double_
    module procedure assert_not_equals_double_in_range_
    module procedure assert_not_equals_1d_double_
    module procedure assert_not_equals_1d_double_in_range_
    module procedure assert_not_equals_2d_double_
    module procedure assert_not_equals_2d_double_in_range_
    module procedure assert_not_equals_complex_
    module procedure assert_not_equals_complex_in_range_
    module procedure assert_not_equals_1d_complex_
    module procedure assert_not_equals_1d_complex_in_range_
    module procedure assert_not_equals_2d_complex_
    module procedure assert_not_equals_2d_complex_in_range_
  !====== end of generated inteface ======

  end interface

  interface assertNotEquals
  !====== begin of generated interface ======
    module procedure assert_not_equals_logical_
    module procedure assert_not_equals_1d_logical_
    module procedure assert_not_equals_2d_logical_
    module procedure assert_not_equals_string_
    module procedure assert_not_equals_1d_string_
    module procedure assert_not_equals_2d_string_
    module procedure assert_not_equals_int_
    module procedure assert_not_equals_1d_int_
    module procedure assert_not_equals_2d_int_
    module procedure assert_not_equals_real_
    module procedure assert_not_equals_real_in_range_
    module procedure assert_not_equals_1d_real_
    module procedure assert_not_equals_1d_real_in_range_
    module procedure assert_not_equals_2d_real_
    module procedure assert_not_equals_2d_real_in_range_
    module procedure assert_not_equals_double_
    module procedure assert_not_equals_double_in_range_
    module procedure assert_not_equals_1d_double_
    module procedure assert_not_equals_1d_double_in_range_
    module procedure assert_not_equals_2d_double_
    module procedure assert_not_equals_2d_double_in_range_
    module procedure assert_not_equals_complex_
    module procedure assert_not_equals_complex_in_range_
    module procedure assert_not_equals_1d_complex_
    module procedure assert_not_equals_1d_complex_in_range_
    module procedure assert_not_equals_2d_complex_
    module procedure assert_not_equals_2d_complex_in_range_
  !====== end of generated inteface ======

  end interface

  interface addSuccess
     module procedure obsolete_addSuccess_
  end interface

  public ::           add_fail
  interface           add_fail
     module procedure add_fail_
     module procedure add_fail_unit_
  end interface

  public ::           addFail
  interface           addFail
     module procedure add_fail_
     module procedure add_fail_unit_
  end interface

  interface getTotalCount
     module procedure obsolete_getTotalCount_
  end interface

  interface getFailedCount
     module procedure obsolete_getFailedCount_
  end interface

  interface isAllSuccessful
     module procedure obsolete_isAllSuccessful_
  end interface

  interface run_test_case
     module procedure run_test_case_
     module procedure run_test_case_named_
  end interface

  interface runTestCase
     module procedure run_test_case_
     module procedure run_test_case_named_
  end interface

  public ::          init_fruit_xml
  interface          init_fruit_xml
    module procedure init_fruit_xml_
  end interface

  public ::          fruit_summary
  interface          fruit_summary
    module procedure fruit_summary_
  end interface

  public ::          fruit_summary_xml
  interface          fruit_summary_xml
    module procedure fruit_summary_xml_
  end interface

  public ::          case_passed_xml
  interface          case_passed_xml
    module procedure case_passed_xml_
  end interface

  public ::          case_failed_xml
  interface          case_failed_xml
    module procedure case_failed_xml_
  end interface

  public ::          override_stdout
  interface          override_stdout
    module procedure override_stdout_
  end interface

  public ::          end_override_stdout
  interface          end_override_stdout
    module procedure end_override_stdout_
  end interface

  interface          override_xml_work
    module procedure override_xml_work_
  end interface

  interface          end_override_xml_work
    module procedure end_override_xml_work_
  end interface

  public ::          get_xml_filename_work
  interface          get_xml_filename_work
    module procedure get_xml_filename_work_
  end interface

  public ::          set_xml_filename_work
  interface          set_xml_filename_work
    module procedure set_xml_filename_work_
  end interface

  public ::          get_message_index
  interface          get_message_index
    module procedure get_message_index_
  end interface

  public ::          get_messages
  interface          get_messages
    module procedure get_messages_
  end interface

  public ::          get_message_array
  interface          get_message_array
    module procedure get_message_array_
  end interface

  interface          set_unit_name
    module procedure set_case_name_
  end interface
  interface          set_case_name
    module procedure set_case_name_
  end interface

  interface          get_unit_name
    module procedure get_case_name_
  end interface
  interface          get_case_name
    module procedure get_case_name_
  end interface

  public ::          fruit_finalize
  interface          fruit_finalize
    module procedure fruit_finalize_
  end interface

  public ::          set_prefix
  interface          set_prefix
    module procedure set_prefix_
  end interface

  public ::          get_prefix
  interface          get_prefix
    module procedure get_prefix_
  end interface

  interface          get_assert_and_case_count
    module procedure get_assert_and_case_count_
  end interface

  interface          fruit_summary_table
    module procedure fruit_summary_table_
  end interface
contains

  subroutine init_fruit(rank)
    integer, intent(in), optional :: rank
    logical :: if_write

    successful_assert_count = 0
    failed_assert_count = 0
    message_index = 1
    message_index_from = 1

    if_write = .true.
    if (present(rank)) then
      if (rank /= 0) if_write = .false.
    endif

    if (if_write) then
      write (stdout,*)
      write (stdout,*) "Test module initialized"
      write (stdout,*)
      write (stdout,*) "   . : successful assert,   F : failed assert "
      write (stdout,*)
    endif
    if ( .not. allocated(message_array) ) then
      allocate(message_array(MSG_ARRAY_INCREMENT))
    end if
  end subroutine init_fruit

  subroutine fruit_finalize_
    if (allocated(message_array)) then
      deallocate(message_array)
    endif
    if(failed_case_count > 0) then
      STOP 1
    endif
  end subroutine fruit_finalize_

  subroutine init_fruit_xml_(rank)
    integer, optional, intent(in) :: rank
    logical :: rank_zero_or_single

    rank_zero_or_single = .true.
    if (present(rank)) then
      if (rank /= 0) then
        rank_zero_or_single = .false.
      endif
    endif


    if (rank_zero_or_single) then
      open (XML_OPEN, file = xml_filename, action ="write", status = "replace")
        write(XML_OPEN, '("<?xml version=""1.0"" encoding=""UTF-8""?>")')
        write(XML_OPEN, '("<testsuites>")')
        write(XML_OPEN, '("  <testsuite ")', advance = "no")
        write(XML_OPEN, '(      "errors=""0"" "   )', advance = "no")
        write(XML_OPEN, '(      "tests=""1"" "    )', advance = "no")
        write(XML_OPEN, '(      "failures=""1"" " )', advance = "no")
        write(XML_OPEN, '(      "name=""", a, """ ")', advance = "no") "name of test suite"
        write(XML_OPEN, '(      "id=""1"">")')

        write(XML_OPEN, &
        &  '("    <testcase name=""", a, """ classname=""", a, """ time=""", a, """>")') &
        &  "dummy_testcase", "dummy_classname", "0"

        write(XML_OPEN, '(a)', advance = "no") "      <failure type=""failure"" message="""
        write(XML_OPEN, '(a)', advance = "no") "FRUIT did not generate regular content of result.xml."
        write(XML_OPEN, '(a)')                 """/>"
        write(XML_OPEN, '("    </testcase>")')

        write(XML_OPEN, '("  </testsuite>")')
        write(XML_OPEN, '("</testsuites>")')
      close(XML_OPEN)
    endif

    open (xml_work, FILE = xml_filename_work, action ="write", status='replace')
    close(xml_work)
  end subroutine init_fruit_xml_

  function  case_delta_t()
    character(len = STRLEN_T) :: case_delta_t
    real :: delta_t
    integer :: case_time_to, time_rate, time_max

    call system_clock(case_time_to, time_rate, time_max)
    if (time_rate > 0) then
      delta_t = real(case_time_to - case_time_from) / real(time_rate)
      if (delta_t < 0) then
        delta_t = delta_t + real(time_max) / real(time_rate)
      endif
    else
      delta_t = 0
    endif

    write(case_delta_t, '(g12.4)') delta_t
    case_delta_t = adjustl(case_delta_t)
  end function case_delta_t

  subroutine case_passed_xml_(tc_name, classname)
    character(*), intent(in) :: tc_name
    character(*), intent(in) :: classname
    character(len = STRLEN_T) :: case_time

    case_time = case_delta_t()

    open (xml_work, FILE = xml_filename_work, position='append')
    write(xml_work, &
   &  '("    <testcase name=""", a, """ classname=""", a, a, """ time=""", a, """/>")') &
   &  trim(tc_name), trim(prefix), trim(classname), trim(case_time)
    close(xml_work)
  end subroutine case_passed_xml_

  subroutine case_failed_xml_(tc_name, classname)
    character(*), intent(in) :: tc_name
    character(*), intent(in) :: classname
    integer :: i
    character(len = STRLEN_T) :: case_time

    case_time = case_delta_t()

    open (xml_work, FILE = xml_filename_work, position='append')
    write(xml_work, &
   &  '("    <testcase name=""", a, """ classname=""", a, a, """ time=""", a, """>")') &
   &  trim(tc_name), trim(prefix), trim(classname), trim(case_time)

    write(xml_work, '("      <failure type=""failure"" message=""")', advance = "no")
    do i = message_index_from, message_index - 1
      write(xml_work, '(a)', advance = "no") trim(strip(message_array(i)))
      if (i == message_index - 1) then
        continue
      else
        write(xml_work, '("&#xA;")', advance="no")
      endif
    enddo
    write(xml_work, '("""/>")')

    write(xml_work, &
   &  '("    </testcase>")')
    close(xml_work)
  end subroutine case_failed_xml_

  subroutine fruit_summary_xml_
    character(len = 1000) :: whole_line
    character(len = 100) :: full_count
    character(len = 100) :: fail_count

    full_count = int_to_str(successful_case_count + failed_case_count)
    fail_count = int_to_str(failed_case_count)

    open (XML_OPEN, file = xml_filename, action ="write", status = "replace")
    write(XML_OPEN, '("<?xml version=""1.0"" encoding=""UTF-8""?>")')
    write(XML_OPEN, '("<testsuites>")')
    write(XML_OPEN, '("  <testsuite errors=""0"" ")', advance = "no")
    write(XML_OPEN, '("tests=""", a, """ ")', advance = "no") &
    &  trim(full_count)
    write(XML_OPEN, '("failures=""", a, """ ")', advance = "no") &
    &  trim(fail_count)
    write(XML_OPEN, '("name=""", a, """ ")', advance = "no") &
    &  "name of test suite"
    write(XML_OPEN, '("id=""1"">")')

    open (xml_work, FILE = xml_filename_work)
    do
      read(xml_work, '(a)', end = 999) whole_line
      write(XML_OPEN, '(a)') trim(whole_line)
    enddo
999 continue
    close(xml_work)

    write(XML_OPEN, '("  </testsuite>")')
    write(XML_OPEN, '("</testsuites>")')
    close(XML_OPEN)
  end subroutine fruit_summary_xml_

  function int_to_str(i)
    integer, intent(in) :: i
    character(LEN = NUMBER_LENGTH) :: int_to_str

    write(int_to_str, '(i10)') i
    int_to_str = adjustl(int_to_str)
  end function int_to_str

  subroutine obsolete_initializeFruit_
    call obsolete_ ("initializeFruit is OBSOLETE.  replaced by init_fruit")
    call init_fruit
  end subroutine obsolete_initializeFruit_

  subroutine obsolete_getTestSummary_
    call obsolete_ ( "getTestSummary is OBSOLETE.  replaced by fruit_summary")
    call fruit_summary_
  end subroutine obsolete_getTestSummary_

  ! Run a named test case
  subroutine run_test_case_named_( tc, tc_name )
    interface
       subroutine tc()
       end subroutine
    end interface
    character(*), intent(in) :: tc_name

    integer :: initial_failed_assert_count

    initial_failed_assert_count = failed_assert_count

    ! Set the name of the unit test
    call set_case_name( tc_name )

    last_passed = .true.
    case_passed = .true.
    linechar_count = 0  !! reset linechar_count for each test case.
    message_index_from = message_index
    call system_clock(case_time_from)

    call tc()

    if ( initial_failed_assert_count .eq. failed_assert_count ) then
       ! If no additional assertions failed during the run of this test case
       ! then the test case was successful
       successful_case_count = successful_case_count+1
    else
       failed_case_count = failed_case_count+1
       case_passed = .false.
    end if

    testCaseIndex = testCaseIndex+1

    ! Reset the name of the unit test back to the default
    call set_case_name( DEFAULT_CASE_NAME )

  end subroutine run_test_case_named_

  ! Run an 'unnamed' test case
  subroutine run_test_case_( tc )
    interface
       subroutine tc()
       end subroutine
    end interface

    call run_test_case_named_( tc, '_unnamed_' )

  end subroutine run_test_case_


  subroutine fruit_summary_
    integer :: i

    write (stdout,*)
    write (stdout,*)
    write (stdout,*) '    Start of FRUIT summary: '
    write (stdout,*)

    if (failed_assert_count > 0) then
       write (stdout,*) 'Some tests failed!'
    else
       write (stdout,*) 'SUCCESSFUL!'
    end if

    write (stdout,*)
    if ( message_index > 1) then
       write (stdout,*) '  -- Failed assertion messages:'

       do i = 1, message_index - 1
          write (stdout,"(A)") '   '//trim(strip(message_array(i)))
       end do

       write (stdout,*) '  -- end of failed assertion messages.'
       write (stdout,*)
    else
       write (stdout,*) '  No messages '
    end if

    if (successful_assert_count + failed_assert_count /= 0) then
       call fruit_summary_table_(&
       & successful_assert_count, failed_assert_count, &
       & successful_case_count,   failed_case_count &
       &)
    end if
    write (stdout, *) '  -- end of FRUIT summary'
  end subroutine fruit_summary_

  subroutine fruit_summary_table_(&
  & succ_assert, fail_assert, &
  & succ_case  , fail_case    &
  &)
    integer, intent(in) :: succ_assert, fail_assert
    integer, intent(in) :: succ_case  , fail_case

    write (stdout,*) 'Total asserts :   ', succ_assert + fail_assert
    write (stdout,*) 'Successful    :   ', succ_assert
    write (stdout,*) 'Failed        :   ', fail_assert
    write (stdout,'("Successful rate:   ",f6.2,"%")')  real(succ_assert) * 100.0 / &
         real (succ_assert + fail_assert)
    write (stdout, *)
    write (stdout,*) 'Successful asserts / total asserts : [ ',&
         succ_assert, '/', succ_assert + fail_assert, ' ]'
    write (stdout,*) 'Successful cases   / total cases   : [ ', succ_case, '/', &
         succ_case + fail_case, ' ]'
  end subroutine fruit_summary_table_

  subroutine obsolete_addSuccess_
    call obsolete_ ("addSuccess is OBSOLETE.  replaced by add_success")
    call add_success
  end subroutine obsolete_addSuccess_

  subroutine add_fail_ (message)
    character (*), intent (in), optional :: message
    call failed_assert_action('none', 'none', message, if_is = .true.)
  end subroutine add_fail_

  subroutine add_fail_unit_ (unitName, message)
    character (*), intent (in) :: unitName
    character (*), intent (in) :: message

    call add_fail_ ("[in " //  unitName // "(fail)]: " //  message)
  end subroutine add_fail_unit_

  subroutine obsolete_isAllSuccessful_(result)
    logical, intent(out) :: result
    call obsolete_ ('subroutine isAllSuccessful is changed to function is_all_successful.')
    result = (failed_assert_count .eq. 0 )
  end subroutine obsolete_isAllSuccessful_

  subroutine is_all_successful(result)
    logical, intent(out) :: result
    result= (failed_assert_count .eq. 0 )
  end subroutine is_all_successful

  ! Private, helper routine to wrap lines of success/failed marks
  subroutine output_mark_( chr )
    character(1), intent(in) :: chr
  !!  integer, save :: linechar_count = 0
  !!  Definition of linechar_count is moved to module,
  !!  so that it can be stashed and restored.

    linechar_count = linechar_count + 1
    if ( linechar_count .lt. MAX_MARKS_PER_LINE ) then
       write(stdout,"(A1)",ADVANCE='NO') chr
    else
       write(stdout,"(A1)",ADVANCE='YES') chr
       linechar_count = 0
    endif

  end subroutine output_mark_

  subroutine success_mark_
    call output_mark_( '.' )
  end subroutine success_mark_

  subroutine failed_mark_
    call output_mark_( 'F' )
  end subroutine failed_mark_

  subroutine increase_message_stack_
    character(len=MSG_LENGTH) :: msg_swap_holder(current_max)

    if (message_index > MAX_MSG_STACK_SIZE) then
       write(stdout,*) "Stop because there are too many error messages to put into stack."
       write(stdout,*) "Try to increase MAX_MSG_STACK_SIZE if you really need so."
       call getTestSummary ()
       stop 1
    end if

    if (message_index > current_max) then
      msg_swap_holder(1:current_max) = message_array(1:current_max)
      deallocate(message_array)
      current_max = current_max + MSG_ARRAY_INCREMENT
      allocate(message_array(current_max))
      message_array(1:current_max - MSG_ARRAY_INCREMENT) &
                   = msg_swap_holder(1: current_max - MSG_ARRAY_INCREMENT)
    end if

    message_array (message_index) = msg
    message_index = message_index + 1
  end subroutine increase_message_stack_


  subroutine get_xml_filename_work_(string)
    character(len = *), intent(out) :: string
    string = trim(xml_filename_work)
  end subroutine get_xml_filename_work_

  subroutine set_xml_filename_work_(string)
    character(len = *), intent(in) :: string
    xml_filename_work = trim(string)
  end subroutine set_xml_filename_work_


  function get_last_message()
    character(len=MSG_LENGTH) :: get_last_message
    if (message_index > 1) then
       get_last_message = strip(message_array(message_index-1), MSG_LENGTH)
    else
       get_last_message = ''
    end if
  end function get_last_message

  subroutine get_message_index_(index)
    integer, intent(out) :: index

    index = message_index
  end subroutine get_message_index_


  subroutine get_message_array_(msgs)
    character(len = *), intent(out) :: msgs(:)
    integer :: i
    msgs(:) = ""

    do i = 1, message_index - 1
      msgs(i) = trim(strip(message_array(i)))
    enddo
  end subroutine get_message_array_


  subroutine get_messages_(msgs)
    character(len = *), intent(out) :: msgs(:)
    integer :: i, j

    msgs(:) = ""
    do i = message_index_from, message_index - 1
      j = i - message_index_from + 1
      if (j > ubound(msgs, 1)) exit
      msgs(j) = trim(strip(message_array(i)))
    enddo
  end subroutine get_messages_

  subroutine obsolete_getTotalCount_ (count)
    integer, intent (out) :: count
    call obsolete_ (' getTotalCount subroutine is replaced by function get_total_count')
    call get_total_count(count)
  end subroutine obsolete_getTotalCount_

  subroutine get_total_count(count)
    integer, intent(out) :: count

    count = successful_assert_count + failed_assert_count
  end subroutine get_total_count

  subroutine obsolete_getFailedCount_ (count)
    integer, intent (out) :: count

    call obsolete_ (' getFailedCount subroutine is replaced by function get_failed_count')
    call get_failed_count (count)

  end subroutine obsolete_getFailedCount_

  subroutine get_failed_count (count)
    integer, intent(out) :: count
    count = failed_assert_count
  end subroutine get_failed_count

  subroutine obsolete_ (message)
    character (*), intent (in), optional :: message
    write (stdout,*)
    write (stdout,*) "<<<<<<<<<<<<<<<<<<<<<<<<<< WARNING from FRUIT >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
    write (stdout,*) message
    write (stdout,*)
    write (stdout,*) " old calls will be replaced in the next release in Jan 2009"
    write (stdout,*) " Naming convention for all the method calls are changed to: first_name from"
    write (stdout,*) " firstName.  Subroutines that will be deleted: assertEquals, assertNotEquals,"
    write (stdout,*) " assertTrue, addSuccessful, addFail, etc."
    write (stdout,*) "<<<<<<<<<<<<<<<<<<<<<<<<<< WARNING from FRUIT >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
    write (stdout,*)
  end subroutine obsolete_

  subroutine add_success
    successful_assert_count = successful_assert_count + 1
    last_passed = .true.
    case_passed = .true.
    call success_mark_
  end subroutine add_success

  subroutine failed_assert_action (expected, got, message, if_is)
    character(*), intent(in) :: expected, got
    character(*), intent(in), optional :: message
    logical, intent(in), optional :: if_is

    if (present(if_is)) then
      call make_error_msg_ (expected, got, if_is,  message)
    else
      call make_error_msg_ (expected, got, .true., message)
    endif
    call increase_message_stack_
    failed_assert_count = failed_assert_count + 1
    last_passed = .false.
    case_passed = .false.
    call failed_mark_
  end subroutine failed_assert_action

  subroutine set_case_name_(value)
    character(*), intent(in) :: value
    case_name = strip(value, MSG_LENGTH)
  end subroutine set_case_name_

  subroutine get_case_name_(value)
    character(*), intent(out) :: value
    value = strip(case_name)
  end subroutine get_case_name_

  subroutine make_error_msg_ (var1, var2, if_is, message)
    character(*), intent(in) :: var1, var2
    logical,      intent(in)           :: if_is
    character(*), intent(in), optional :: message

    msg = '[' // trim(strip(case_name)) // ']: '
    if (if_is) then
      msg = trim(msg) //     'Expected'
    else
      msg = trim(msg) // 'Expected Not'
    endif
    msg = trim(msg) // " " // '[' // trim(strip(var1)) // '], '
    msg = trim(msg) // " " // 'Got'
    msg = trim(msg) // " " // '[' // trim(strip(var2)) // ']'

    if (present(message)) then
       msg = trim(msg) // '; User message: [' // trim(message) // ']'
    endif
  end subroutine make_error_msg_

  function is_last_passed()
    logical:: is_last_passed
    is_last_passed = last_passed
  end function is_last_passed

  function is_case_passed()
    logical:: is_case_passed
    is_case_passed = case_passed
  end function is_case_passed

  subroutine override_stdout_(write_unit, filename)
    integer, intent(in) ::    write_unit
    character(len = *), intent(in) :: filename

    stdout = write_unit
    open(stdout, file = filename, action = "write", status = "replace")
  end subroutine override_stdout_

  subroutine override_xml_work_(new_unit, filename)
    integer, intent(in) ::    new_unit
    character(len = *), intent(in) :: filename

    xml_work = new_unit
    xml_filename_work = filename
    open(xml_work, file = filename, action = "write", status = "replace")
  end subroutine override_xml_work_

  subroutine stash_test_suite
    stashed_suite%successful_assert_count = successful_assert_count
                  successful_assert_count = 0

    stashed_suite%failed_assert_count     = failed_assert_count
                  failed_assert_count = 0

    allocate(stashed_suite%message_array(current_max))
             stashed_suite%message_array(1:message_index) = &
                         & message_array(1:message_index)
    deallocate(message_array)
      allocate(message_array(MSG_ARRAY_INCREMENT))

    stashed_suite%message_index = message_index
                  message_index = 1
    stashed_suite%message_index_from = message_index_from
                  message_index_from = 1

    stashed_suite%current_max = current_max
                  current_max = 50
    stashed_suite%successful_case_count = successful_case_count
                  successful_case_count = 0
    stashed_suite%failed_case_count     = failed_case_count
                  failed_case_count = 0
    stashed_suite%testCaseIndex         = testCaseIndex
                  testCaseIndex = 1
    stashed_suite%case_name = case_name
                  case_name = DEFAULT_CASE_NAME

    stashed_suite%last_passed = last_passed
                  last_passed = .false.
    stashed_suite%case_passed = case_passed
                  case_passed = .false.
    stashed_suite%case_time_from = case_time_from
                  case_time_from = 0
    stashed_suite%linechar_count = linechar_count
                  linechar_count = 0
  end subroutine stash_test_suite

  subroutine restore_test_suite
    successful_assert_count = stashed_suite%successful_assert_count
    failed_assert_count     = stashed_suite%failed_assert_count

    message_index = stashed_suite%message_index
    message_index_from = stashed_suite%message_index_from
    current_max  = stashed_suite%current_max

    deallocate(message_array)
    allocate(  message_array(current_max))
    message_array(1:message_index) = &
             & stashed_suite%message_array(1:message_index)
    deallocate(stashed_suite%message_array)

    successful_case_count = stashed_suite%successful_case_count
    failed_case_count     = stashed_suite%failed_case_count
    testCaseIndex         = stashed_suite%testCaseIndex

    case_name          = stashed_suite%case_name
    last_passed        = stashed_suite%last_passed
    case_passed        = stashed_suite%case_passed
    case_time_from     = stashed_suite%case_time_from
    linechar_count     = stashed_suite%linechar_count
  end subroutine restore_test_suite

  subroutine end_override_stdout_
    close(stdout)
    stdout = STDOUT_DEFAULT
  end subroutine end_override_stdout_

  subroutine end_override_xml_work_
    close(xml_work)
    xml_work = XML_WORK_DEFAULT
    xml_filename_work = XML_FN_WORK_DEF
  end subroutine end_override_xml_work_

  subroutine set_prefix_(str)
    character (len = *), intent(in) :: str
    character (len = len_trim(str)) :: str2

    str2 = trim(adjustl(str))
    if (len_trim(str2) <= FRUIT_PREFIX_LEN_MAX) then
      prefix = str2
    else
      prefix = str2(1:FRUIT_PREFIX_LEN_MAX)
    endif
  end subroutine set_prefix_

  subroutine get_prefix_(str)
    character (len = *), intent(out) :: str

    if (len(str) <= len(prefix)) then
      str = trim(prefix)
    else
      str = prefix
    endif
  end subroutine get_prefix_

  subroutine get_assert_and_case_count_(fail_assert, suc_assert, fail_case, suc_case)
    integer, intent(out) :: fail_assert, suc_assert, fail_case, suc_case

    fail_assert =     failed_assert_count
     suc_assert = successful_assert_count
    fail_case   =     failed_case_count
     suc_case   = successful_case_count
  end subroutine get_assert_and_case_count_

  !--------------------------------------------------------------------------------
  ! all assertions
  !--------------------------------------------------------------------------------
  subroutine obsolete_assert_true_logical_(var1, message)
    logical, intent (in) :: var1
    character (*), intent (in), optional :: message

    call obsolete_ ('assertTrue subroutine is replaced by function assert_true')
    call assert_true(var1, message)
  end subroutine obsolete_assert_true_logical_

  subroutine assert_true (var1, message)
    logical, intent (in) :: var1
    character (*), intent (in), optional :: message

    if ( var1 .eqv. .true.) then
       call add_success
    else
       call failed_assert_action(to_s(.true.), to_s(var1), message, if_is = .true.)
    end if
  end subroutine assert_true


  subroutine assert_false_(var1, message)
    logical, intent(in) :: var1
    character(len = *), intent(in), optional :: message

    if (var1 .eqv. .false.) then
      call add_success
    else
      call failed_assert_action(to_s(.true.), to_s(var1), message, if_is = .false.)
    endif
  end subroutine assert_false_

  !====== begin of generated code ======
  !------ 0d_logical ------
  subroutine assert_eq_logical_(var1, var2, message)

    logical, intent (in) :: var1, var2

    character(len = *), intent (in), optional :: message

        if (var1 .neqv. var2) then
          call failed_assert_action(&
          & to_s(var1), &
          & to_s(var2), message, if_is = .true.)
          return
        endif

    call add_success
  end subroutine assert_eq_logical_

  !------ 1d_logical ------
  subroutine assert_eq_1d_logical_(var1, var2, n, message)
    integer, intent (in) :: n
    integer              :: i
    logical, intent (in) :: var1(n), var2(n)

    character(len = *), intent (in), optional :: message
    do i = 1, n
        if (var1(i) .neqv. var2(i)) then
          call failed_assert_action(&
          & to_s(var1(i)), &
          & to_s(var2(i)), '1d array has difference, ' // message, if_is = .true.)
          return
        endif
    enddo
    call add_success
  end subroutine assert_eq_1d_logical_

  !------ 2d_logical ------
  subroutine assert_eq_2d_logical_(var1, var2, n, m, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    logical, intent (in) :: var1(n, m), var2(n, m)

    character(len = *), intent (in), optional :: message
    do j = 1, m
      do i = 1, n
        if (var1(i, j) .neqv. var2(i, j)) then
          call failed_assert_action(&
          & to_s(var1(i, j)), &
          & to_s(var2(i, j)), '2d array has difference, ' // message, if_is = .true.)
          return
        endif
      enddo
    enddo
    call add_success
  end subroutine assert_eq_2d_logical_

  !------ 0d_string ------
  subroutine assert_eq_string_(var1, var2, message)

    character (len = *), intent (in) :: var1, var2

    character(len = *), intent (in), optional :: message

        if (trim(strip(var1)) /= trim(strip(var2))) then
          call failed_assert_action(&
          & to_s(var1), &
          & to_s(var2), message, if_is = .true.)
          return
        endif

    call add_success
  end subroutine assert_eq_string_

  !------ 1d_string ------
  subroutine assert_eq_1d_string_(var1, var2, n, message)
    integer, intent (in) :: n
    integer              :: i
    character (len = *), intent (in) :: var1(n), var2(n)

    character(len = *), intent (in), optional :: message
    do i = 1, n
        if (trim(strip(var1(i))) /= trim(strip(var2(i)))) then
          call failed_assert_action(&
          & to_s(var1(i)), &
          & to_s(var2(i)), '1d array has difference, ' // message, if_is = .true.)
          return
        endif
    enddo
    call add_success
  end subroutine assert_eq_1d_string_

  !------ 2d_string ------
  subroutine assert_eq_2d_string_(var1, var2, n, m, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    character (len = *), intent (in) :: var1(n, m), var2(n, m)

    character(len = *), intent (in), optional :: message
    do j = 1, m
      do i = 1, n
        if (trim(strip(var1(i, j))) /= trim(strip(var2(i, j)))) then
          call failed_assert_action(&
          & to_s(var1(i, j)), &
          & to_s(var2(i, j)), '2d array has difference, ' // message, if_is = .true.)
          return
        endif
      enddo
    enddo
    call add_success
  end subroutine assert_eq_2d_string_

  !------ 0d_int ------
  subroutine assert_eq_int_(var1, var2, message)

    integer, intent (in) :: var1, var2

    character(len = *), intent (in), optional :: message

        if (var1 /= var2) then
          call failed_assert_action(&
          & to_s(var1), &
          & to_s(var2), message, if_is = .true.)
          return
        endif

    call add_success
  end subroutine assert_eq_int_

  !------ 1d_int ------
  subroutine assert_eq_1d_int_(var1, var2, n, message)
    integer, intent (in) :: n
    integer              :: i
    integer, intent (in) :: var1(n), var2(n)

    character(len = *), intent (in), optional :: message
    do i = 1, n
        if (var1(i) /= var2(i)) then
          call failed_assert_action(&
          & to_s(var1(i)), &
          & to_s(var2(i)), '1d array has difference, ' // message, if_is = .true.)
          return
        endif
    enddo
    call add_success
  end subroutine assert_eq_1d_int_

  !------ 2d_int ------
  subroutine assert_eq_2d_int_(var1, var2, n, m, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    integer, intent (in) :: var1(n, m), var2(n, m)

    character(len = *), intent (in), optional :: message
    do j = 1, m
      do i = 1, n
        if (var1(i, j) /= var2(i, j)) then
          call failed_assert_action(&
          & to_s(var1(i, j)), &
          & to_s(var2(i, j)), '2d array has difference, ' // message, if_is = .true.)
          return
        endif
      enddo
    enddo
    call add_success
  end subroutine assert_eq_2d_int_

  !------ 0d_real ------
  subroutine assert_eq_real_(var1, var2, message)

    real, intent (in) :: var1, var2

    character(len = *), intent (in), optional :: message

        if ((var1 < var2) .or. (var1 > var2)) then
          call failed_assert_action(&
          & to_s(var1), &
          & to_s(var2), message, if_is = .true.)
          return
        endif

    call add_success
  end subroutine assert_eq_real_

  !------ 0d_real ------
  subroutine assert_eq_real_in_range_(var1, var2, delta, message)

    real, intent (in) :: var1, var2
    real, intent (in) :: delta
    character(len = *), intent (in), optional :: message

        if (abs(var1 - var2) > delta) then
          call failed_assert_action(&
          & to_s(var1), &
          & to_s(var2), message, if_is = .true.)
          return
        endif

    call add_success
  end subroutine assert_eq_real_in_range_

  !------ 1d_real ------
  subroutine assert_eq_1d_real_(var1, var2, n, message)
    integer, intent (in) :: n
    integer              :: i
    real, intent (in) :: var1(n), var2(n)

    character(len = *), intent (in), optional :: message
    do i = 1, n
        if ((var1(i) < var2(i)) .or. (var1(i) > var2(i))) then
          call failed_assert_action(&
          & to_s(var1(i)), &
          & to_s(var2(i)), '1d array has difference, ' // message, if_is = .true.)
          return
        endif
    enddo
    call add_success
  end subroutine assert_eq_1d_real_

  !------ 1d_real ------
  subroutine assert_eq_1d_real_in_range_(var1, var2, n, delta, message)
    integer, intent (in) :: n
    integer              :: i
    real, intent (in) :: var1(n), var2(n)
    real, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    do i = 1, n
        if (abs(var1(i) - var2(i)) > delta) then
          call failed_assert_action(&
          & to_s(var1(i)), &
          & to_s(var2(i)), '1d array has difference, ' // message, if_is = .true.)
          return
        endif
    enddo
    call add_success
  end subroutine assert_eq_1d_real_in_range_

  !------ 2d_real ------
  subroutine assert_eq_2d_real_(var1, var2, n, m, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    real, intent (in) :: var1(n, m), var2(n, m)

    character(len = *), intent (in), optional :: message
    do j = 1, m
      do i = 1, n
        if ((var1(i, j) < var2(i, j)) .or. (var1(i, j) > var2(i, j))) then
          call failed_assert_action(&
          & to_s(var1(i, j)), &
          & to_s(var2(i, j)), '2d array has difference, ' // message, if_is = .true.)
          return
        endif
      enddo
    enddo
    call add_success
  end subroutine assert_eq_2d_real_

  !------ 2d_real ------
  subroutine assert_eq_2d_real_in_range_(var1, var2, n, m, delta, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    real, intent (in) :: var1(n, m), var2(n, m)
    real, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    do j = 1, m
      do i = 1, n
        if (abs(var1(i, j) - var2(i, j)) > delta) then
          call failed_assert_action(&
          & to_s(var1(i, j)), &
          & to_s(var2(i, j)), '2d array has difference, ' // message, if_is = .true.)
          return
        endif
      enddo
    enddo
    call add_success
  end subroutine assert_eq_2d_real_in_range_

  !------ 0d_double ------
  subroutine assert_eq_double_(var1, var2, message)

    double precision, intent (in) :: var1, var2

    character(len = *), intent (in), optional :: message

        if ((var1 < var2) .or. (var1 > var2)) then
          call failed_assert_action(&
          & to_s(var1), &
          & to_s(var2), message, if_is = .true.)
          return
        endif

    call add_success
  end subroutine assert_eq_double_

  !------ 0d_double ------
  subroutine assert_eq_double_in_range_(var1, var2, delta, message)

    double precision, intent (in) :: var1, var2
    double precision, intent (in) :: delta
    character(len = *), intent (in), optional :: message

        if (abs(var1 - var2) > delta) then
          call failed_assert_action(&
          & to_s(var1), &
          & to_s(var2), message, if_is = .true.)
          return
        endif

    call add_success
  end subroutine assert_eq_double_in_range_

  !------ 1d_double ------
  subroutine assert_eq_1d_double_(var1, var2, n, message)
    integer, intent (in) :: n
    integer              :: i
    double precision, intent (in) :: var1(n), var2(n)

    character(len = *), intent (in), optional :: message
    do i = 1, n
        if ((var1(i) < var2(i)) .or. (var1(i) > var2(i))) then
          call failed_assert_action(&
          & to_s(var1(i)), &
          & to_s(var2(i)), '1d array has difference, ' // message, if_is = .true.)
          return
        endif
    enddo
    call add_success
  end subroutine assert_eq_1d_double_

  !------ 1d_double ------
  subroutine assert_eq_1d_double_in_range_(var1, var2, n, delta, message)
    integer, intent (in) :: n
    integer              :: i
    double precision, intent (in) :: var1(n), var2(n)
    double precision, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    do i = 1, n
        if (abs(var1(i) - var2(i)) > delta) then
          call failed_assert_action(&
          & to_s(var1(i)), &
          & to_s(var2(i)), '1d array has difference, ' // message, if_is = .true.)
          return
        endif
    enddo
    call add_success
  end subroutine assert_eq_1d_double_in_range_

  !------ 2d_double ------
  subroutine assert_eq_2d_double_(var1, var2, n, m, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    double precision, intent (in) :: var1(n, m), var2(n, m)

    character(len = *), intent (in), optional :: message
    do j = 1, m
      do i = 1, n
        if ((var1(i, j) < var2(i, j)) .or. (var1(i, j) > var2(i, j))) then
          call failed_assert_action(&
          & to_s(var1(i, j)), &
          & to_s(var2(i, j)), '2d array has difference, ' // message, if_is = .true.)
          return
        endif
      enddo
    enddo
    call add_success
  end subroutine assert_eq_2d_double_

  !------ 2d_double ------
  subroutine assert_eq_2d_double_in_range_(var1, var2, n, m, delta, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    double precision, intent (in) :: var1(n, m), var2(n, m)
    double precision, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    do j = 1, m
      do i = 1, n
        if (abs(var1(i, j) - var2(i, j)) > delta) then
          call failed_assert_action(&
          & to_s(var1(i, j)), &
          & to_s(var2(i, j)), '2d array has difference, ' // message, if_is = .true.)
          return
        endif
      enddo
    enddo
    call add_success
  end subroutine assert_eq_2d_double_in_range_

  !------ 0d_complex ------
  subroutine assert_eq_complex_(var1, var2, message)

    complex(kind=kind(1.0D0)), intent (in) :: var1, var2

    character(len = *), intent (in), optional :: message

        if ((real (var1) < real (var2)) .or. &
&(real (var1) > real (var2)) .or. &
&(aimag(var1) < aimag(var2)) .or. &
&(aimag(var1) > aimag(var2))) then
          call failed_assert_action(&
          & to_s(var1), &
          & to_s(var2), message, if_is = .true.)
          return
        endif

    call add_success
  end subroutine assert_eq_complex_

  !------ 0d_complex ------
  subroutine assert_eq_complex_in_range_(var1, var2, delta, message)

    complex(kind=kind(1.0D0)), intent (in) :: var1, var2
    double precision, intent (in) :: delta
    character(len = *), intent (in), optional :: message

        if (abs(var1 - var2) > delta) then
          call failed_assert_action(&
          & to_s(var1), &
          & to_s(var2), message, if_is = .true.)
          return
        endif

    call add_success
  end subroutine assert_eq_complex_in_range_

  !------ 1d_complex ------
  subroutine assert_eq_1d_complex_(var1, var2, n, message)
    integer, intent (in) :: n
    integer              :: i
    complex(kind=kind(1.0D0)), intent (in) :: var1(n), var2(n)

    character(len = *), intent (in), optional :: message
    do i = 1, n
        if ((real (var1(i)) < real (var2(i))) .or. &
&(real (var1(i)) > real (var2(i))) .or. &
&(aimag(var1(i)) < aimag(var2(i))) .or. &
&(aimag(var1(i)) > aimag(var2(i)))) then
          call failed_assert_action(&
          & to_s(var1(i)), &
          & to_s(var2(i)), '1d array has difference, ' // message, if_is = .true.)
          return
        endif
    enddo
    call add_success
  end subroutine assert_eq_1d_complex_

  !------ 1d_complex ------
  subroutine assert_eq_1d_complex_in_range_(var1, var2, n, delta, message)
    integer, intent (in) :: n
    integer              :: i
    complex(kind=kind(1.0D0)), intent (in) :: var1(n), var2(n)
    double precision, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    do i = 1, n
        if (abs(var1(i) - var2(i)) > delta) then
          call failed_assert_action(&
          & to_s(var1(i)), &
          & to_s(var2(i)), '1d array has difference, ' // message, if_is = .true.)
          return
        endif
    enddo
    call add_success
  end subroutine assert_eq_1d_complex_in_range_

  !------ 2d_complex ------
  subroutine assert_eq_2d_complex_(var1, var2, n, m, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    complex(kind=kind(1.0D0)), intent (in) :: var1(n, m), var2(n, m)

    character(len = *), intent (in), optional :: message
    do j = 1, m
      do i = 1, n
        if ((real (var1(i, j)) < real (var2(i, j))) .or. &
&(real (var1(i, j)) > real (var2(i, j))) .or. &
&(aimag(var1(i, j)) < aimag(var2(i, j))) .or. &
&(aimag(var1(i, j)) > aimag(var2(i, j)))) then
          call failed_assert_action(&
          & to_s(var1(i, j)), &
          & to_s(var2(i, j)), '2d array has difference, ' // message, if_is = .true.)
          return
        endif
      enddo
    enddo
    call add_success
  end subroutine assert_eq_2d_complex_

  !------ 2d_complex ------
  subroutine assert_eq_2d_complex_in_range_(var1, var2, n, m, delta, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    complex(kind=kind(1.0D0)), intent (in) :: var1(n, m), var2(n, m)
    double precision, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    do j = 1, m
      do i = 1, n
        if (abs(var1(i, j) - var2(i, j)) > delta) then
          call failed_assert_action(&
          & to_s(var1(i, j)), &
          & to_s(var2(i, j)), '2d array has difference, ' // message, if_is = .true.)
          return
        endif
      enddo
    enddo
    call add_success
  end subroutine assert_eq_2d_complex_in_range_

  !------ 0d_logical ------
  subroutine assert_not_equals_logical_(var1, var2, message)

    logical, intent (in) :: var1, var2

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.

        if (var1 .neqv. var2) then
          same_so_far = .false.
        endif

    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1), &
      & to_s(var2), message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_logical_

  !------ 1d_logical ------
  subroutine assert_not_equals_1d_logical_(var1, var2, n, message)
    integer, intent (in) :: n
    integer              :: i
    logical, intent (in) :: var1(n), var2(n)

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do i = 1, n
        if (var1(i) .neqv. var2(i)) then
          same_so_far = .false.
        endif
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1)), &
      & to_s(var2(1)), '1d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_1d_logical_

  !------ 2d_logical ------
  subroutine assert_not_equals_2d_logical_(var1, var2, n, m, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    logical, intent (in) :: var1(n, m), var2(n, m)

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do j = 1, m
      do i = 1, n
        if (var1(i, j) .neqv. var2(i, j)) then
          same_so_far = .false.
        endif
      enddo
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1, 1)), &
      & to_s(var2(1, 1)), '2d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_2d_logical_

  !------ 0d_string ------
  subroutine assert_not_equals_string_(var1, var2, message)

    character (len = *), intent (in) :: var1, var2

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.

        if (trim(strip(var1)) /= trim(strip(var2))) then
          same_so_far = .false.
        endif

    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1), &
      & to_s(var2), message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_string_

  !------ 1d_string ------
  subroutine assert_not_equals_1d_string_(var1, var2, n, message)
    integer, intent (in) :: n
    integer              :: i
    character (len = *), intent (in) :: var1(n), var2(n)

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do i = 1, n
        if (trim(strip(var1(i))) /= trim(strip(var2(i)))) then
          same_so_far = .false.
        endif
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1)), &
      & to_s(var2(1)), '1d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_1d_string_

  !------ 2d_string ------
  subroutine assert_not_equals_2d_string_(var1, var2, n, m, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    character (len = *), intent (in) :: var1(n, m), var2(n, m)

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do j = 1, m
      do i = 1, n
        if (trim(strip(var1(i, j))) /= trim(strip(var2(i, j)))) then
          same_so_far = .false.
        endif
      enddo
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1, 1)), &
      & to_s(var2(1, 1)), '2d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_2d_string_

  !------ 0d_int ------
  subroutine assert_not_equals_int_(var1, var2, message)

    integer, intent (in) :: var1, var2

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.

        if (var1 /= var2) then
          same_so_far = .false.
        endif

    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1), &
      & to_s(var2), message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_int_

  !------ 1d_int ------
  subroutine assert_not_equals_1d_int_(var1, var2, n, message)
    integer, intent (in) :: n
    integer              :: i
    integer, intent (in) :: var1(n), var2(n)

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do i = 1, n
        if (var1(i) /= var2(i)) then
          same_so_far = .false.
        endif
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1)), &
      & to_s(var2(1)), '1d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_1d_int_

  !------ 2d_int ------
  subroutine assert_not_equals_2d_int_(var1, var2, n, m, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    integer, intent (in) :: var1(n, m), var2(n, m)

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do j = 1, m
      do i = 1, n
        if (var1(i, j) /= var2(i, j)) then
          same_so_far = .false.
        endif
      enddo
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1, 1)), &
      & to_s(var2(1, 1)), '2d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_2d_int_

  !------ 0d_real ------
  subroutine assert_not_equals_real_(var1, var2, message)

    real, intent (in) :: var1, var2

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.

        if ((var1 < var2) .or. (var1 > var2)) then
          same_so_far = .false.
        endif

    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1), &
      & to_s(var2), message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_real_

  !------ 0d_real ------
  subroutine assert_not_equals_real_in_range_(var1, var2, delta, message)

    real, intent (in) :: var1, var2
    real, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.

        if (abs(var1 - var2) > delta) then
          same_so_far = .false.
        endif

    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1), &
      & to_s(var2), message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_real_in_range_

  !------ 1d_real ------
  subroutine assert_not_equals_1d_real_(var1, var2, n, message)
    integer, intent (in) :: n
    integer              :: i
    real, intent (in) :: var1(n), var2(n)

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do i = 1, n
        if ((var1(i) < var2(i)) .or. (var1(i) > var2(i))) then
          same_so_far = .false.
        endif
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1)), &
      & to_s(var2(1)), '1d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_1d_real_

  !------ 1d_real ------
  subroutine assert_not_equals_1d_real_in_range_(var1, var2, n, delta, message)
    integer, intent (in) :: n
    integer              :: i
    real, intent (in) :: var1(n), var2(n)
    real, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do i = 1, n
        if (abs(var1(i) - var2(i)) > delta) then
          same_so_far = .false.
        endif
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1)), &
      & to_s(var2(1)), '1d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_1d_real_in_range_

  !------ 2d_real ------
  subroutine assert_not_equals_2d_real_(var1, var2, n, m, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    real, intent (in) :: var1(n, m), var2(n, m)

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do j = 1, m
      do i = 1, n
        if ((var1(i, j) < var2(i, j)) .or. (var1(i, j) > var2(i, j))) then
          same_so_far = .false.
        endif
      enddo
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1, 1)), &
      & to_s(var2(1, 1)), '2d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_2d_real_

  !------ 2d_real ------
  subroutine assert_not_equals_2d_real_in_range_(var1, var2, n, m, delta, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    real, intent (in) :: var1(n, m), var2(n, m)
    real, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do j = 1, m
      do i = 1, n
        if (abs(var1(i, j) - var2(i, j)) > delta) then
          same_so_far = .false.
        endif
      enddo
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1, 1)), &
      & to_s(var2(1, 1)), '2d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_2d_real_in_range_

  !------ 0d_double ------
  subroutine assert_not_equals_double_(var1, var2, message)

    double precision, intent (in) :: var1, var2

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.

        if ((var1 < var2) .or. (var1 > var2)) then
          same_so_far = .false.
        endif

    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1), &
      & to_s(var2), message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_double_

  !------ 0d_double ------
  subroutine assert_not_equals_double_in_range_(var1, var2, delta, message)

    double precision, intent (in) :: var1, var2
    double precision, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.

        if (abs(var1 - var2) > delta) then
          same_so_far = .false.
        endif

    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1), &
      & to_s(var2), message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_double_in_range_

  !------ 1d_double ------
  subroutine assert_not_equals_1d_double_(var1, var2, n, message)
    integer, intent (in) :: n
    integer              :: i
    double precision, intent (in) :: var1(n), var2(n)

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do i = 1, n
        if ((var1(i) < var2(i)) .or. (var1(i) > var2(i))) then
          same_so_far = .false.
        endif
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1)), &
      & to_s(var2(1)), '1d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_1d_double_

  !------ 1d_double ------
  subroutine assert_not_equals_1d_double_in_range_(var1, var2, n, delta, message)
    integer, intent (in) :: n
    integer              :: i
    double precision, intent (in) :: var1(n), var2(n)
    double precision, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do i = 1, n
        if (abs(var1(i) - var2(i)) > delta) then
          same_so_far = .false.
        endif
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1)), &
      & to_s(var2(1)), '1d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_1d_double_in_range_

  !------ 2d_double ------
  subroutine assert_not_equals_2d_double_(var1, var2, n, m, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    double precision, intent (in) :: var1(n, m), var2(n, m)

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do j = 1, m
      do i = 1, n
        if ((var1(i, j) < var2(i, j)) .or. (var1(i, j) > var2(i, j))) then
          same_so_far = .false.
        endif
      enddo
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1, 1)), &
      & to_s(var2(1, 1)), '2d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_2d_double_

  !------ 2d_double ------
  subroutine assert_not_equals_2d_double_in_range_(var1, var2, n, m, delta, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    double precision, intent (in) :: var1(n, m), var2(n, m)
    double precision, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do j = 1, m
      do i = 1, n
        if (abs(var1(i, j) - var2(i, j)) > delta) then
          same_so_far = .false.
        endif
      enddo
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1, 1)), &
      & to_s(var2(1, 1)), '2d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_2d_double_in_range_

  !------ 0d_complex ------
  subroutine assert_not_equals_complex_(var1, var2, message)

    complex(kind=kind(1.0D0)), intent (in) :: var1, var2

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.

        if ((real (var1) < real (var2)) .or. &
&(real (var1) > real (var2)) .or. &
&(aimag(var1) < aimag(var2)) .or. &
&(aimag(var1) > aimag(var2))) then
          same_so_far = .false.
        endif

    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1), &
      & to_s(var2), message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_complex_

  !------ 0d_complex ------
  subroutine assert_not_equals_complex_in_range_(var1, var2, delta, message)

    complex(kind=kind(1.0D0)), intent (in) :: var1, var2
    double precision, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.

        if (abs(var1 - var2) > delta) then
          same_so_far = .false.
        endif

    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1), &
      & to_s(var2), message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_complex_in_range_

  !------ 1d_complex ------
  subroutine assert_not_equals_1d_complex_(var1, var2, n, message)
    integer, intent (in) :: n
    integer              :: i
    complex(kind=kind(1.0D0)), intent (in) :: var1(n), var2(n)

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do i = 1, n
        if ((real (var1(i)) < real (var2(i))) .or. &
&(real (var1(i)) > real (var2(i))) .or. &
&(aimag(var1(i)) < aimag(var2(i))) .or. &
&(aimag(var1(i)) > aimag(var2(i)))) then
          same_so_far = .false.
        endif
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1)), &
      & to_s(var2(1)), '1d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_1d_complex_

  !------ 1d_complex ------
  subroutine assert_not_equals_1d_complex_in_range_(var1, var2, n, delta, message)
    integer, intent (in) :: n
    integer              :: i
    complex(kind=kind(1.0D0)), intent (in) :: var1(n), var2(n)
    double precision, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do i = 1, n
        if (abs(var1(i) - var2(i)) > delta) then
          same_so_far = .false.
        endif
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1)), &
      & to_s(var2(1)), '1d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_1d_complex_in_range_

  !------ 2d_complex ------
  subroutine assert_not_equals_2d_complex_(var1, var2, n, m, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    complex(kind=kind(1.0D0)), intent (in) :: var1(n, m), var2(n, m)

    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do j = 1, m
      do i = 1, n
        if ((real (var1(i, j)) < real (var2(i, j))) .or. &
&(real (var1(i, j)) > real (var2(i, j))) .or. &
&(aimag(var1(i, j)) < aimag(var2(i, j))) .or. &
&(aimag(var1(i, j)) > aimag(var2(i, j)))) then
          same_so_far = .false.
        endif
      enddo
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1, 1)), &
      & to_s(var2(1, 1)), '2d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_2d_complex_

  !------ 2d_complex ------
  subroutine assert_not_equals_2d_complex_in_range_(var1, var2, n, m, delta, message)
    integer, intent (in) :: n, m
    integer              :: i, j
    complex(kind=kind(1.0D0)), intent (in) :: var1(n, m), var2(n, m)
    double precision, intent (in) :: delta
    character(len = *), intent (in), optional :: message
    logical :: same_so_far

    same_so_far = .true.
    do j = 1, m
      do i = 1, n
        if (abs(var1(i, j) - var2(i, j)) > delta) then
          same_so_far = .false.
        endif
      enddo
    enddo
    if (same_so_far) then
      call failed_assert_action(&
      & to_s(var1(1, 1)), &
      & to_s(var2(1, 1)), '2d array has no difference, ' // message, if_is = .false.)
      return
    endif
    call add_success
  end subroutine assert_not_equals_2d_complex_in_range_

  !====== end of generated code ======

end module fruit

#!/usr/bin/env bash

# Start of configuration
preamble="Copyright +(\([cC]\) +)?"
postamble=",? +Advanced +Micro +Devices, +Inc\."
find_pattern="$preamble([0-9]{4}-)?[0-9]{4}$postamble"
# printf format string, receives the current year as a parameter
uptodate_pattern="$preamble([0-9]{4}-)?%d$postamble"
# <pattern>/<replacement> interpreted with sed syntax, also passed to printf
# printf interprets '\' escape sequences so they must be escaped
# The capture groups are as follows:
#   - \1 is the whole preamble text
#   - \3 is the start year, \2 is skipped because it is used for an optional part of the preamble
#   - \5 is the end of the copyright statement after the end year, \4 would be the original end year
#     as written in the file, it is replaced by the current year instead.
replace_pattern="($preamble)([0-9]{4})(-[0-9]{4})?($postamble)/\\\1\\\3-%d\\\5"
# End of configuration

print_help() { printf -- \
"\033[36musuage\033[0m: \033[33mcheck_year.sh [-h] [-u] [-a] [-d <SHA>] [-k] [-v]\033[0m
\033[36mdescription\033[0m: Checks for if the copyright year in the staged files is up to date and displays the files with out-of-date copyright statements. Exits with '0' if successful and with '1' if something is out of date.
\033[36moptions\033[0m:
  \033[34m-h\033[0m       Displays this message.
  \033[34m-u\033[0m       Automatically updates the copyright year
  \033[34m-a\033[0m       Automatically applies applies the changes to current staging environment. Implies '-u' and '-c'.
  \033[34m-c\033[0m       Compare files to the index instead of the working tree.
  \033[34m-d <SHA>\033[0m Compare using the diff of a hash.
  \033[34m-k\033[0m       Compare using the fork point: where this branch and 'remotes/origin/HEAD' diverge.
  \033[34m-q\033[0m       Suppress updates about progress.
  \033[34m-v\033[0m       Verbose output.
Use '\033[33mgit config --local hooks.updateCopyright <true|false>\033[0m' to automatically apply copyright changes on commit.
"
}

# argument parsing
apply=false
update=false
verbose=false
forkdiff=false
quiet=false
cached=false

while getopts "auhvkqcd:" arg; do
    case $arg in
        a) update=true;apply=true;cached=true;;
        u) update=true;;
        v) verbose=true;;
        k) forkdiff=true;;
        q) quiet=true;;
        c) cached=true;;
        d) diff_hash=${OPTARG};;
        h) print_help; exit;;
        *) print help; exit 1;;
    esac
done

# If set, check all files changed since the fork point
if $forkdiff; then
    branch="$(git rev-parse --abbrev-ref HEAD)"
    remote="$(git config --local --get "branch.$branch.remote" || echo 'origin')"
    source_commit="remotes/$remote/HEAD"

    # don't use fork-point for finding fork point (lol)
    diff_hash="$(git merge-base "$source_commit" "$branch")"
fi

if [ -n "${diff_hash}" ]; then
    $verbose && printf -- "Using base commit: %s\n" "${diff_hash}"
else
    diff_hash="HEAD"
fi

# Current year
year="$(date +%Y)"

# Enable rename detection with full matches only, this skips copyright checks for file name only
# changes.
diff_opts=(-z --name-only '--diff-filter=MA' '--find-renames=100%')
git_grep_opts=(-z --extended-regexp --ignore-case --no-recursive -I)
if $cached; then
    diff_opts+=(--cached)
    git_grep_opts+=(--cached)
fi

! $quiet && printf -- "Checking if copyright statements are up-to-date... "
mapfile -d $'\0' changed_files < <(git diff-index "${diff_opts[@]}" "$diff_hash" | LANG=C.UTF-8 sort -z)

if ! (( ${#changed_files[@]} )); then
    ! $quiet && printf -- "\033[32mDone!\033[0m\n"
    $verbose && printf -- "\033[36mNo changed files found.\033[0m\n"
    exit 0
fi;

mapfile -d $'\0' found_copyright < <(                                      \
    git grep "${git_grep_opts[@]}" --files-with-matches -e "$find_pattern" \
        -- "${changed_files[@]}" |                                         \
    LANG=C.UTF-8 sort -z)

outdated_copyright=()
if (( ${#found_copyright[@]} )); then
    # uptodate_pattern variable holds the format string using it as such is intentional
    # shellcheck disable=SC2059
    printf -v uptodate_pattern -- "$uptodate_pattern" "$year"
    mapfile -d $'\0' outdated_copyright < <(                                        \
        git grep "${git_grep_opts[@]}" --files-without-match -e "$uptodate_pattern" \
            -- "${found_copyright[@]}" |                                            \
        LANG=C.UTF-8 sort -z)
fi

! $quiet && printf -- "\033[32mDone!\033[0m\n"
if $verbose; then
    # Compute the files that don't have a copyright as the set difference of
    # `changed_files and `found_copyright`
    mapfile -d $'\0' notfound_copyright < <(                                   \
        printf -- '%s\0' "${changed_files[@]}" |                               \
        LANG=C.UTF-8 comm -z -23 - <(printf -- '%s\0' "${found_copyright[@]}"))

    if (( ${#notfound_copyright[@]} )); then
        printf -- "\033[36mCouldn't find a copyright statement in %d file(s):\033[0m\n" \
            "${#notfound_copyright[@]}"
        printf -- '  - %q\n' "${notfound_copyright[@]}"
    fi

    # Similarly the up-to-date files are the difference of `found_copyright` and `outdated_copyright`
    mapfile -d $'\0' uptodate_copyright < <(                                       \
        printf -- '%s\0' "${found_copyright[@]}" |                                 \
        LANG=C.UTF-8 comm -z -23 - <(printf -- '%s\0' "${outdated_copyright[@]}"))

    if (( ${#uptodate_copyright[@]} )); then
        printf -- "\033[36mThe copyright statement was already up to date in %d file(s):\033[0m\n" \
            "${#uptodate_copyright[@]}"
        printf -- '  - %q\n' "${uptodate_copyright[@]}"
    fi
fi

if ! (( ${#outdated_copyright[@]} )); then
    exit 0
fi

printf -- \
"\033[31m==== COPYRIGHT OUT OF DATE ====\033[0m
\033[36m%d file(s) need(s) to be updated:\033[0m\n" "${#outdated_copyright[@]}"
printf -- '  - %q\n' "${outdated_copyright[@]}"

# If we don't need to update, we early exit.
if ! $update; then
    printf -- \
"\nRun '\033[33mscripts/copyright-date/check-copyright.sh -u\033[0m' to update the copyright statement(s). See '-h' for more info,
or set '\033[33mgit config --local hooks.updateCopyright true\033[0m' to automatically update copyrights when committing.\n"
    exit 1
fi

if $apply; then
    ! $quiet && printf -- "Updating copyrights and staging changes... "
else
    ! $quiet && printf -- "Updating copyrights... "
fi

# replace_pattern variable holds a format string, using it as such is intentional
# shellcheck disable=SC2059
printf -v replace_pattern -- "$replace_pattern" "$year"
# Just update the files in place if only touching the working-tree
if ! $apply; then
    sed --regexp-extended --separate "s/$replace_pattern/g" -i "${outdated_copyright[@]}"
    printf -- "\033[32mDone!\033[0m\n"
    exit 0
fi

generate_patch() {
    # Sed command to create a hunk for a copyright statement fix
    # expects input to be line number then copyright statement on the next line
    to_hunk_cmd="{# Print hunk header, move to the next line
                  s/.+/@@ -&,1 +&,1 @@/;n
                  # Print removed line by prepending '-' to it
                  ;s/^/-/;p
                  # Print added line, replace the '-' with '+' and replace the copyright statement
                  s/^-/+/;s/$replace_pattern/g}"

    # Run file-names through git ls-files, just to get a (possibly) quoted name for each
    mapfile -t -d $'\n' quoted_files < <(git ls-files --cached -- "${outdated_copyright[@]}")
    for ((i = 0;i < ${#outdated_copyright[@]}; i++)); do
        file="${outdated_copyright["$i"]}"
        quoted="${quoted_files["$i"]}"
        # Drop the quote from the start and end (to avoid quoting twice)
        escaped="${quoted#\"}"; escaped="${escaped%\"}"
        a="\"a/$escaped\""
        b="\"b/$escaped\""

        printf -- "diff --git %s %s\n--- %s\n+++ %s\n" "$a" "$b" "$a" "$b"

        # Print line number and line for each line with a copyright statement
        git cat-file blob ":$file" |                               \
            sed --quiet --regexp-extended "/$find_pattern/{=;p}" | \
            sed --regexp-extended "$to_hunk_cmd"
    done
}

patch_file="$(git rev-parse --git-dir)/copyright-fix.patch"
generate_patch > "$patch_file"

# Cleanup patch file when the script exits
finish () {
    rm -f "$patch_file"
}
# The trap will be invoked whenever the script exits, even due to a signal, this is a bash only
# feature
trap finish EXIT

if ! git apply --unidiff-zero < "$patch_file"; then
    printf -- "\033[31mFailed to apply changes to working tree.
Perhaps the fix is already applied, but not yet staged?\n\033[0m"
    exit 1
fi

if ! git apply --cached --unidiff-zero < "$patch_file"; then
    printf -- "\033[31mFailed to apply change to the index.\n\033[0m"
    exit 1
fi

! $quiet && printf -- "\033[32mDone!\033[0m\n"
exit 0

#!/usr/bin/env bash

SOURCE_COMMIT="$1"
if [ "$#" -gt 0 ]; then
    shift
fi

# If no source commit is given target the default branch
if [ "x$SOURCE_COMMIT" = "x" ]; then
    # If remote is not set use the remote of the current branch or fallback to "origin"
    if [ "x$REMOTE" = "x" ]; then
        BRANCH="$(git rev-parse --abbrev-ref HEAD)"
        REMOTE="$(git config --local --get "branch.$BRANCH.remote" || echo 'origin')"
    fi
    SOURCE_COMMIT="remotes/$REMOTE/HEAD"
fi

# Force colored diff output
DIFF_COLOR_SAVED="$(git config --local --get color.diff)"
if [ "x$DIFF_COLOR_SAVED" != "x" ]; then
    git config --local --replace-all "color.diff" "always"
else
    git config --local --add "color.diff" "always"
fi

scratch="$(mktemp -t check-format.XXXXXXXXXX)"
finish () {
    # Remove temporary file
    rm -rf "$scratch"
    # Restore setting
    if [ "x$DIFF_COLOR_SAVED" != "x" ]; then
        git config --local --replace-all "color.diff" "$DIFF_COLOR_SAVED"
    else
        git config --local --unset "color.diff"
    fi
}
# The trap will be invoked whenever the script exits, even due to a signal, this is a bash only
# feature
trap finish EXIT

GIT_CLANG_FORMAT="${GIT_CLANG_FORMAT:-git-clang-format}"
"$GIT_CLANG_FORMAT" --style=file --diff "$@" "$SOURCE_COMMIT" > "$scratch"

# Check for no-ops
grep '^no modified files to format$\|^clang-format did not modify any files$' \
    "$scratch" > /dev/null && exit 0

# Dump formatting diff and signal failure
printf \
"\033[31m==== FORMATTING VIOLATIONS DETECTED ====\033[0m
run '\033[33m%s --style=file %s %s\033[0m' to apply these formating changes\n\n" \
"$GIT_CLANG_FORMAT" "$*" "$SOURCE_COMMIT"

cat "$scratch"
exit 1

---
name: Bug report
about: Create a report to help us improve
title: ''
labels: ''
assignees: ''

---

**Describe the bug**
A clear and concise description of what the bug is.

**To Reproduce**
Steps to reproduce the behavior:
1. Install '...' version '...'
2. Run '...' with data '...'
3. See error on logfile '...'

**Expected behavior**
A clear and concise description of what you expected to happen.

**Log-files**
Add *full* logfiles to help explain your problem.

**Environment**
Make sure that ROCm is correctly installed and run the following command:
```
printf '=== environment\n' > environment.txt && 
printf '\n\n=== date\n' >> environment.txt && date >> environment.txt && 
printf '\n\n=== Linux Kernel\n' >> environment.txt && uname -a  >> environment.txt && 
printf '\n\n=== rocm-smi' >> environment.txt && rocm-smi  >> environment.txt && 
printf '\n\n' >> environment.txt && hipconfig  >> environment.txt && 
printf '\n\n=== rocminfo\n' >> environment.txt && rocminfo  >> environment.txt && 
printf '\n\n=== lspci VGA\n' >> environment.txt && lspci | grep -i vga >> environment.txt
```

Attach `environment.txt`

**Additional context**
Add any other context about the problem here.

# Contributing to hipRAND

## How to contribute

Our code contriubtion guidelines closely follows the model of [GitHub pull-requests](https://help.github.com/articles/using-pull-requests/).  This repository follows the [git flow](http://nvie.com/posts/a-successful-git-branching-model/) workflow, which dictates a /master branch where releases are cut, and a /develop branch which serves as an integration branch for new code.
  * A [git extention](https://github.com/nvie/gitflow) has been developed to ease the use of the 'git flow' methodology, but requires manual installation by the user.  Refer to the projects wiki.

## Pull-request guidelines
* target the **develop** branch for integration
* ensure code builds successfully
* do not break existing test cases
* new functionality will only be merged with new unit tests
  * new unit tests should integrate within the existing [googletest framework](https://github.com/google/googletest/blob/master/googletest/docs/Primer.md)
  * tests must have good code coverage
  * code must also have benchmark tests, and performance must be acceptable to maintainers
